/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.fortran.lexer

enum class FortranToken {
    NUMBER_LITERAL,

    INCLUDE,
    PROGRAM,
    MODULE,
    SUBROUTINE,
    INTERFACE,
    FUNCTION,
    CONTAINS,
    RECURSIVE,
    USE,
    CALL,
    RETURN,
    IMPLICIT,
    EXPLICIT,
    NONE,
    DATA,
    TYPE,
    PARAMETER,
    ALLOCATE,
    ALLOCATABLE,
    ALLOCATED,
    DEALLOCATE,
    INTEGER,
    DOUBLE,
    PRECISION,
    COMPLEX,
    CHARACTER,
    DIMENSION,
    KIND,
    CASE,
    ERROR,
    SELECT,
    DEFAULT,
    CONTINUE,
    CYCLE,
    DO,
    WHILE,
    ELSE,
    IF,
    ELSEIF,
    THEN,
    ELSEWHERE,
    END,
    ENDIF,
    ENDDO,
    FORALL,
    WHERE,
    EXIT,
    GOTO,
    PAUSE,
    STOP,
    BACKSPACE,
    CLOSE,
    ENDFILE,
    INQUIRE,
    OPEN,
    PRINT,
    READ,
    REWIND,
    WRITE,
    FORMAT,
    AINT,
    AMAX0,
    AMIN0,
    CEILING,
    CMPLX,
    DCMPLX,
    DFLOAT,
    DPROD,
    FLOAT,
    FLOOR,
    IFIX,
    IMAG,
    INT,
    LOGICAL,
    MODULO,
    REAL,
    TRANSFER,
    ZEXT,
    ABS,
    ACOS,
    AIMAG,
    ALOG,
    ALOG10,
    AMAX1,
    AMIN1,
    AMOD,
    ANINT,
    ASIN,
    ATAN,
    ATAN2,
    CABS,
    CCOS,
    CHAR,
    CLOG,
    CONJG,
    COS,
    COSH,
    CSIN,
    CSQRT,
    DABS,
    DACOS,
    DASIN,
    DATAN,
    DATAN2,
    DBLE,
    DCOS,
    DCOSH,
    DDIM,
    DEXP,
    DIM,
    DINT,
    DLOG,
    DLOG10,
    DMAX1,
    DMIN1,
    DMOD,
    DNINT,
    DREAL,
    DSIGN,
    DSIN,
    DSINH,
    DSQRT,
    DTAN,
    DTANH,
    EXP,
    IABS,
    ICHAR,
    IDIM,
    IDINT,
    IDNINT,
    INDEX,
    ISIGN,
    LEN,
    LGE,
    LGT,
    LLE,
    LLT,
    LOG,
    LOG10,
    MAX,
    MAX0,
    MAX1,
    MIN,
    MIN0,
    MIN1,
    MOD,
    NINT,
    SIGN,
    SIN,
    SINH,
    SNGL,
    SQRT,
    TAN,
    TANH,

    TRUE,
    FALSE,

    LPAREN,
    RPAREN,
    LBRACE,
    RBRACE,
    LBRACK,
    RBRACK,
    LT_OPERATOR,
    GT_OPERATOR,
    LTEQ,
    GTEQ,
    AND_OPERATOR,
    DIVEQ,
    EQEQ,
    EQ_OPERATOR,
    DOUBLE_COLON,
    LT,
    GT,
    EQ,
    NE,
    LE,
    GE,
    AND,
    OR,

    DOUBLE_QUOTED_STRING,
    SINGLE_QUOTED_STRING,

    LINE_COMMENT,

    IDENTIFIER,
    WHITESPACE,
    BAD_CHARACTER,
    EOF
}