/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.go.lexer

enum class GoToken {
    LITERAL_NUMBER_DECIMAL_INT,
    LITERAL_NUMBER_HEXADECIMAL,
    LITERAL_NUMBER_FLOAT,

    BREAK,
    CASE,
    CHAN,
    CONST,
    CONTINUE,
    DEFAULT,
    DEFER,
    ELSE,
    FALLTHROUGH,
    FOR,
    FUNC,
    GO,
    GOTO,
    IF,
    IMPORT,
    INTERFACE,
    MAP,
    PACKAGE,
    RANGE,
    SELECT,
    STRUCT,
    SWITCH,
    TYPE,
    VAR,
    RETURN,

    BOOL,
    STRING,
    INT,
    INT_8,
    INT_16,
    INT_32,
    INT_64,
    UINT,
    UINT_8,
    UINT_16,
    UINT_32,
    UINT_64,
    UINTPTR,
    BYTE,
    RUNE,
    FLOAT_32,
    FLOAT_64,
    COMPLEX_64,
    COMPLEX_128,

    APPEND,
    CAP,
    CLOSE,
    COMPLEX,
    COPY,
    DELETE,
    IMAG,
    LEN,
    MAKE,
    NEW,
    PANIC,
    PRINT,
    PRINTLN,
    REAL,
    RECOVER,
    COMPARE,
    CONTAINS,
    CONTAINS_ANY,
    CONTAINS_RUNE,
    COUNT,
    EQUALS_FOLD,
    FIELDS,
    FIELDS_FUNC,
    HAS_PREFIX,
    HAS_SUFFIX,
    INDEX,
    INDEX_ANY,
    INDEX_BYTE,
    INDEX_FUNC,
    INDEX_RUNE,
    JOIN,
    LAST_INDEX,
    LAST_INDEX_ANY,
    LAST_INDEX_BYTE,
    LAST_INDEX_FUNC,
    REPEAT,
    REPLACE,
    REPLACE_ALL,
    SPLIT,
    SPLIT_AFTER,
    SPLIT_AFTER_N,
    SPLIT_N,
    TITLE,
    TO_LOWER,
    TO_LOWER_SPECIAL,
    TO_TITLE,
    TO_TITLE_SPECIAL,
    TO_UPPER,
    TO_UPPSER_SPECIAL,
    TRIM,
    TRIM_FUNC,
    TRIM_LEFT,
    TRIM_LEFT_FUNC,
    TRIM_PREFIX,
    TRIM_RIGHT,
    TRIM_RIGHT_FUNC,
    TRIM_SPACE,
    TRIM_SUFFIX,

    TRUE,
    FALSE,
    NIL,

    LPAREN,
    RPAREN,
    LBRACE,
    RBRACE,
    LBRACK,
    RBRACK,
    TRIGRAPH,
    EQ,
    COLONEQ,
    PLUS,
    MINUS,
    MULT,
    DIV,
    MOD,
    TILDE,
    LT,
    ARROW,
    GT,
    GTGT,
    LTLT,
    EQEQ,
    PLUSEQ,
    MINUSEQ,
    MULTEQ,
    DIVEQ,
    MODEQ,
    ANDEQ,
    OREQ,
    XOREQ,
    GTEQ,
    LTEQ,
    NOTEQ,
    GTGTEQ,
    LTLTEQ,
    XOR,
    AND,
    ANDAND,
    ANDXOR,
    ANDXOREQ,
    ELLIPSIS,
    OR,
    OROR,
    QUEST,
    NOT,
    PLUSPLUS,
    MINUSMINUS,
    COLON,
    SEMICOLON,
    COMMA,
    DOT,

    DOUBLE_QUOTED_STRING,
    SINGLE_QUOTED_STRING,

    LINE_COMMENT,
    BLOCK_COMMENT,

    IDENTIFIER,
    WHITESPACE,
    BAD_CHARACTER,
    EOF
}