/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.html.lexer;

import org.jetbrains.annotations.NotNull;

@SuppressWarnings("all")

/**
 * This class is a scanner generated by
 * <a href="http://www.jflex.de/">JFlex</a> 1.8.2
 * from the specification file <tt>html.flex</tt>
 */
public class HtmlLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int DOC_TYPE = 2;
  public static final int COMMENT = 4;
  public static final int START_TAG_NAME = 6;
  public static final int END_TAG_NAME = 8;
  public static final int BEFORE_TAG_ATTRIBUTES = 10;
  public static final int TAG_ATTRIBUTES = 12;
  public static final int ATTRIBUTE_VALUE_START = 14;
  public static final int ATTRIBUTE_VALUE_DQ = 16;
  public static final int ATTRIBUTE_VALUE_SQ = 18;
  public static final int PROCESSING_INSTRUCTION = 20;
  public static final int TAG_CHARACTERS = 22;
  public static final int C_COMMENT_START = 24;
  public static final int C_COMMENT_END = 26;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2,  2,  3,  3,  4,  4,  5,  5,  6,  6,  7,  7, 
     8,  8,  9,  9, 10, 10, 11, 11, 12, 12, 13, 13
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\1\u0200\1\u0300\1\u0400\1\u0500\1\u0600\1\u0700"+
    "\1\u0800\1\u0900\1\u0a00\1\u0b00\1\u0c00\1\u0d00\1\u0e00\1\u0f00"+
    "\1\u1000\1\u0100\1\u1100\1\u1200\1\u1300\1\u0100\1\u1400\1\u1500"+
    "\1\u1600\1\u1700\1\u1800\1\u1900\1\u1a00\1\u1b00\1\u0100\1\u1c00"+
    "\1\u1d00\1\u1e00\12\u1f00\1\u2000\1\u2100\1\u2200\1\u1f00\1\u2300"+
    "\1\u2400\2\u1f00\31\u0100\1\u2500\121\u0100\1\u2600\4\u0100\1\u2700"+
    "\1\u0100\1\u2800\1\u2900\1\u2a00\1\u2b00\1\u2c00\1\u2d00\53\u0100"+
    "\1\u2e00\41\u1f00\1\u0100\1\u2f00\1\u3000\1\u0100\1\u3100\1\u3200"+
    "\1\u3300\1\u3400\1\u1f00\1\u3500\1\u3600\1\u3700\1\u3800\1\u0100"+
    "\1\u3900\1\u3a00\1\u3b00\1\u3c00\1\u3d00\1\u3e00\1\u3f00\1\u1f00"+
    "\1\u4000\1\u4100\1\u4200\1\u4300\1\u4400\1\u4500\1\u4600\1\u4700"+
    "\1\u4800\1\u4900\1\u4a00\1\u4b00\1\u1f00\1\u4c00\1\u4d00\1\u4e00"+
    "\1\u1f00\3\u0100\1\u4f00\1\u5000\1\u5100\12\u1f00\4\u0100\1\u5200"+
    "\17\u1f00\2\u0100\1\u5300\41\u1f00\2\u0100\1\u5400\1\u5500\2\u1f00"+
    "\1\u5600\1\u5700\27\u0100\1\u5800\2\u0100\1\u5900\45\u1f00\1\u0100"+
    "\1\u5a00\1\u5b00\11\u1f00\1\u5c00\27\u1f00\1\u5d00\1\u5e00\1\u5f00"+
    "\1\u6000\11\u1f00\1\u6100\1\u6200\5\u1f00\1\u6300\1\u6400\4\u1f00"+
    "\1\u6500\21\u1f00\246\u0100\1\u6600\20\u0100\1\u6700\1\u6800\25\u0100"+
    "\1\u6900\34\u0100\1\u6a00\14\u1f00\2\u0100\1\u6b00\u0e05\u1f00";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\2\1\1\0\2\1\22\0\1\1\1\2\1\3"+
    "\1\4\1\5\1\0\1\6\1\7\2\10\3\0\1\11"+
    "\1\12\1\13\12\14\1\15\1\16\1\17\1\0\1\20"+
    "\1\21\1\0\1\22\1\23\1\24\1\25\1\26\1\22"+
    "\1\27\1\30\1\31\2\27\1\32\1\33\1\27\1\34"+
    "\1\35\3\27\1\36\1\37\2\27\1\40\1\41\1\27"+
    "\1\42\1\43\1\44\1\0\1\15\1\0\1\45\1\46"+
    "\1\24\1\25\1\26\1\22\1\47\1\30\1\31\2\27"+
    "\1\50\1\51\1\52\1\53\1\54\1\55\1\27\1\56"+
    "\1\57\1\60\2\27\1\40\1\41\1\27\1\0\1\10"+
    "\10\0\1\61\44\0\1\27\12\0\1\27\4\0\1\27"+
    "\5\0\27\27\1\0\37\27\1\0\u01ca\27\4\0\14\27"+
    "\16\0\5\27\7\0\1\27\1\0\1\27\201\0\5\27"+
    "\1\0\2\27\2\0\4\27\1\0\1\27\6\0\1\27"+
    "\1\0\3\27\1\0\1\27\1\0\24\27\1\0\123\27"+
    "\1\0\213\27\10\0\246\27\1\0\46\27\2\0\1\27"+
    "\6\0\51\27\107\0\33\27\4\0\4\27\55\0\53\27"+
    "\43\0\2\27\1\0\143\27\1\0\1\27\17\0\2\27"+
    "\7\0\2\27\12\0\3\27\2\0\1\27\20\0\1\27"+
    "\1\0\36\27\35\0\131\27\13\0\1\27\30\0\41\27"+
    "\11\0\2\27\4\0\1\27\5\0\26\27\4\0\1\27"+
    "\11\0\1\27\3\0\1\27\27\0\31\27\7\0\13\27"+
    "\65\0\25\27\1\0\10\27\106\0\66\27\3\0\1\27"+
    "\22\0\1\27\7\0\12\27\17\0\20\27\4\0\10\27"+
    "\2\0\2\27\2\0\26\27\1\0\7\27\1\0\1\27"+
    "\3\0\4\27\3\0\1\27\20\0\1\27\15\0\2\27"+
    "\1\0\3\27\16\0\2\27\12\0\1\27\10\0\6\27"+
    "\4\0\2\27\2\0\26\27\1\0\7\27\1\0\2\27"+
    "\1\0\2\27\1\0\2\27\37\0\4\27\1\0\1\27"+
    "\23\0\3\27\20\0\11\27\1\0\3\27\1\0\26\27"+
    "\1\0\7\27\1\0\2\27\1\0\5\27\3\0\1\27"+
    "\22\0\1\27\17\0\2\27\27\0\1\27\13\0\10\27"+
    "\2\0\2\27\2\0\26\27\1\0\7\27\1\0\2\27"+
    "\1\0\5\27\3\0\1\27\36\0\2\27\1\0\3\27"+
    "\17\0\1\27\21\0\1\27\1\0\6\27\3\0\3\27"+
    "\1\0\4\27\3\0\2\27\1\0\1\27\1\0\2\27"+
    "\3\0\2\27\3\0\3\27\3\0\14\27\26\0\1\27"+
    "\64\0\10\27\1\0\3\27\1\0\27\27\1\0\20\27"+
    "\3\0\1\27\32\0\3\27\5\0\2\27\36\0\1\27"+
    "\4\0\10\27\1\0\3\27\1\0\27\27\1\0\12\27"+
    "\1\0\5\27\3\0\1\27\40\0\1\27\1\0\2\27"+
    "\17\0\2\27\22\0\10\27\1\0\3\27\1\0\51\27"+
    "\2\0\1\27\20\0\1\27\5\0\3\27\10\0\3\27"+
    "\30\0\6\27\5\0\22\27\3\0\30\27\1\0\11\27"+
    "\1\0\1\27\2\0\7\27\72\0\60\27\1\0\2\27"+
    "\14\0\7\27\72\0\2\27\1\0\1\27\1\0\5\27"+
    "\1\0\30\27\1\0\1\27\1\0\12\27\1\0\2\27"+
    "\11\0\1\27\2\0\5\27\1\0\1\27\25\0\4\27"+
    "\40\0\1\27\77\0\10\27\1\0\44\27\33\0\5\27"+
    "\163\0\53\27\24\0\1\27\20\0\6\27\4\0\4\27"+
    "\3\0\1\27\3\0\2\27\7\0\3\27\4\0\15\27"+
    "\14\0\1\27\21\0\46\27\1\0\1\27\5\0\1\27"+
    "\2\0\53\27\1\0\115\27\1\0\4\27\2\0\7\27"+
    "\1\0\1\27\1\0\4\27\2\0\51\27\1\0\4\27"+
    "\2\0\41\27\1\0\4\27\2\0\7\27\1\0\1\27"+
    "\1\0\4\27\2\0\17\27\1\0\71\27\1\0\4\27"+
    "\2\0\103\27\45\0\20\27\20\0\126\27\2\0\6\27"+
    "\3\0\u016c\27\2\0\21\27\1\0\32\27\5\0\113\27"+
    "\6\0\10\27\7\0\15\27\1\0\4\27\16\0\22\27"+
    "\16\0\22\27\16\0\15\27\1\0\3\27\17\0\64\27"+
    "\43\0\1\27\4\0\1\27\103\0\131\27\7\0\5\27"+
    "\2\0\42\27\1\0\1\27\5\0\106\27\12\0\37\27"+
    "\61\0\36\27\2\0\5\27\13\0\54\27\4\0\32\27"+
    "\66\0\27\27\11\0\65\27\122\0\1\27\135\0\57\27"+
    "\21\0\7\27\67\0\36\27\15\0\2\27\12\0\54\27"+
    "\32\0\44\27\51\0\3\27\12\0\44\27\2\0\11\27"+
    "\7\0\53\27\2\0\3\27\51\0\4\27\1\0\6\27"+
    "\1\0\2\27\3\0\1\27\5\0\300\27\100\0\26\27"+
    "\2\0\6\27\2\0\46\27\2\0\6\27\2\0\10\27"+
    "\1\0\1\27\1\0\1\27\1\0\1\27\1\0\37\27"+
    "\2\0\65\27\1\0\7\27\1\0\1\27\3\0\3\27"+
    "\1\0\7\27\3\0\4\27\2\0\6\27\4\0\15\27"+
    "\5\0\3\27\1\0\7\27\53\0\2\61\107\0\1\27"+
    "\15\0\1\27\20\0\15\27\145\0\1\27\4\0\1\27"+
    "\2\0\12\27\1\0\1\27\3\0\5\27\6\0\1\27"+
    "\1\0\1\27\1\0\1\27\1\0\4\27\1\0\13\27"+
    "\2\0\4\27\5\0\5\27\4\0\1\27\64\0\2\27"+
    "\u017b\0\57\27\1\0\57\27\1\0\205\27\6\0\4\27"+
    "\3\0\2\27\14\0\46\27\1\0\1\27\5\0\1\27"+
    "\2\0\70\27\7\0\1\27\20\0\27\27\11\0\7\27"+
    "\1\0\7\27\1\0\7\27\1\0\7\27\1\0\7\27"+
    "\1\0\7\27\1\0\7\27\1\0\7\27\120\0\1\27"+
    "\325\0\2\27\52\0\5\27\5\0\2\27\4\0\126\27"+
    "\6\0\3\27\1\0\132\27\1\0\4\27\5\0\53\27"+
    "\1\0\136\27\21\0\33\27\65\0\306\27\112\0\360\27"+
    "\20\0\215\27\103\0\56\27\2\0\15\27\3\0\20\27"+
    "\12\0\2\27\24\0\57\27\20\0\37\27\2\0\106\27"+
    "\61\0\11\27\2\0\147\27\2\0\65\27\2\0\5\27"+
    "\60\0\13\27\1\0\3\27\1\0\4\27\1\0\27\27"+
    "\35\0\64\27\16\0\62\27\76\0\6\27\3\0\1\27"+
    "\1\0\2\27\13\0\34\27\12\0\27\27\31\0\35\27"+
    "\7\0\57\27\34\0\1\27\20\0\5\27\1\0\12\27"+
    "\12\0\5\27\1\0\51\27\27\0\3\27\1\0\10\27"+
    "\24\0\27\27\3\0\1\27\3\0\62\27\1\0\1\27"+
    "\3\0\2\27\2\0\5\27\2\0\1\27\1\0\1\27"+
    "\30\0\3\27\2\0\13\27\7\0\3\27\14\0\6\27"+
    "\2\0\6\27\2\0\6\27\11\0\7\27\1\0\7\27"+
    "\1\0\53\27\1\0\14\27\10\0\163\27\35\0\244\27"+
    "\14\0\27\27\4\0\61\27\4\0\156\27\2\0\152\27"+
    "\46\0\7\27\14\0\5\27\5\0\1\27\1\0\12\27"+
    "\1\0\15\27\1\0\5\27\1\0\1\27\1\0\2\27"+
    "\1\0\2\27\1\0\154\27\41\0\153\27\22\0\100\27"+
    "\2\0\66\27\50\0\14\27\164\0\5\27\1\0\207\27"+
    "\44\0\32\27\6\0\32\27\13\0\131\27\3\0\6\27"+
    "\2\0\6\27\2\0\6\27\2\0\3\27\43\0\14\27"+
    "\1\0\32\27\1\0\23\27\1\0\2\27\1\0\17\27"+
    "\2\0\16\27\42\0\173\27\205\0\35\27\3\0\61\27"+
    "\57\0\40\27\15\0\24\27\1\0\10\27\6\0\46\27"+
    "\12\0\36\27\2\0\44\27\4\0\10\27\60\0\236\27"+
    "\22\0\44\27\4\0\44\27\4\0\50\27\10\0\64\27"+
    "\234\0\67\27\11\0\26\27\12\0\10\27\230\0\6\27"+
    "\2\0\1\27\1\0\54\27\1\0\2\27\3\0\1\27"+
    "\2\0\27\27\12\0\27\27\11\0\37\27\101\0\23\27"+
    "\1\0\2\27\12\0\26\27\12\0\32\27\106\0\70\27"+
    "\6\0\2\27\100\0\1\27\17\0\4\27\1\0\3\27"+
    "\1\0\35\27\52\0\35\27\3\0\35\27\43\0\10\27"+
    "\1\0\34\27\33\0\66\27\12\0\26\27\12\0\23\27"+
    "\15\0\22\27\156\0\111\27\67\0\63\27\15\0\63\27"+
    "\15\0\44\27\334\0\35\27\12\0\1\27\10\0\26\27"+
    "\232\0\27\27\14\0\65\27\113\0\55\27\40\0\31\27"+
    "\32\0\44\27\35\0\1\27\13\0\43\27\3\0\1\27"+
    "\14\0\60\27\16\0\4\27\25\0\1\27\1\0\1\27"+
    "\43\0\22\27\1\0\31\27\124\0\7\27\1\0\1\27"+
    "\1\0\4\27\1\0\17\27\1\0\12\27\7\0\57\27"+
    "\46\0\10\27\2\0\2\27\2\0\26\27\1\0\7\27"+
    "\1\0\2\27\1\0\5\27\3\0\1\27\22\0\1\27"+
    "\14\0\5\27\236\0\65\27\22\0\4\27\24\0\1\27"+
    "\40\0\60\27\24\0\2\27\1\0\1\27\270\0\57\27"+
    "\51\0\4\27\44\0\60\27\24\0\1\27\73\0\53\27"+
    "\15\0\1\27\107\0\33\27\345\0\54\27\164\0\100\27"+
    "\37\0\1\27\240\0\10\27\2\0\47\27\20\0\1\27"+
    "\1\0\1\27\34\0\1\27\12\0\50\27\7\0\1\27"+
    "\25\0\1\27\13\0\56\27\23\0\1\27\42\0\71\27"+
    "\7\0\11\27\1\0\45\27\21\0\1\27\61\0\36\27"+
    "\160\0\7\27\1\0\2\27\1\0\46\27\25\0\1\27"+
    "\31\0\6\27\1\0\2\27\1\0\40\27\16\0\1\27"+
    "\u0147\0\23\27\15\0\232\27\346\0\304\27\274\0\57\27"+
    "\321\0\107\27\271\0\71\27\7\0\37\27\161\0\36\27"+
    "\22\0\60\27\20\0\4\27\37\0\25\27\5\0\23\27"+
    "\260\0\100\27\200\0\113\27\5\0\1\27\102\0\15\27"+
    "\100\0\2\27\1\0\1\27\34\0\370\27\10\0\363\27"+
    "\15\0\37\27\61\0\3\27\21\0\4\27\10\0\u018c\27"+
    "\4\0\153\27\5\0\15\27\3\0\11\27\7\0\12\27"+
    "\146\0\125\27\1\0\107\27\1\0\2\27\2\0\1\27"+
    "\2\0\2\27\2\0\4\27\1\0\14\27\1\0\1\27"+
    "\1\0\7\27\1\0\101\27\1\0\4\27\2\0\10\27"+
    "\1\0\7\27\1\0\34\27\1\0\4\27\1\0\5\27"+
    "\1\0\1\27\3\0\7\27\1\0\u0154\27\2\0\31\27"+
    "\1\0\31\27\1\0\37\27\1\0\31\27\1\0\37\27"+
    "\1\0\31\27\1\0\37\27\1\0\31\27\1\0\37\27"+
    "\1\0\31\27\1\0\10\27\64\0\55\27\12\0\7\27"+
    "\20\0\1\27\u0171\0\54\27\24\0\305\27\73\0\104\27"+
    "\7\0\1\27\264\0\4\27\1\0\33\27\1\0\2\27"+
    "\1\0\1\27\2\0\1\27\1\0\12\27\1\0\4\27"+
    "\1\0\1\27\1\0\1\27\6\0\1\27\4\0\1\27"+
    "\1\0\1\27\1\0\1\27\1\0\3\27\1\0\2\27"+
    "\1\0\1\27\2\0\1\27\1\0\1\27\1\0\1\27"+
    "\1\0\1\27\1\0\1\27\1\0\2\27\1\0\1\27"+
    "\2\0\4\27\1\0\7\27\1\0\4\27\1\0\4\27"+
    "\1\0\1\27\1\0\12\27\1\0\21\27\5\0\3\27"+
    "\1\0\5\27\1\0\21\27\104\0\327\27\51\0\65\27"+
    "\13\0\336\27\2\0\u0182\27\16\0\u0131\27\37\0\36\27"+
    "\342\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[27648];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\1\11\0\1\2\3\0\1\1\1\3\5\1\4\4"+
    "\1\5\2\4\4\6\1\7\1\10\2\11\1\12\1\13"+
    "\1\11\1\14\1\11\1\15\1\16\1\17\1\16\1\20"+
    "\1\21\1\22\2\20\1\23\1\24\2\23\1\2\1\25"+
    "\1\4\3\26\3\27\1\6\1\27\1\30\7\0\1\31"+
    "\1\32\1\33\6\0\1\31\1\34\1\20\2\0\1\35"+
    "\2\0\1\36\7\0\1\37\3\0\1\40\1\0\1\41"+
    "\1\42\2\0\1\43\1\0\1\44\1\0\1\45\1\4"+
    "\3\0\1\46\2\0\1\47";

  private static int [] zzUnpackAction() {
    int [] result = new int[121];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\62\0\144\0\226\0\310\0\372\0\u012c\0\u015e"+
    "\0\u0190\0\u01c2\0\u01f4\0\u0226\0\u0258\0\u028a\0\u02bc\0\u02ee"+
    "\0\u0320\0\u0352\0\u0384\0\u03b6\0\u03e8\0\u0320\0\u041a\0\u0352"+
    "\0\u044c\0\u0320\0\u047e\0\u04b0\0\u0320\0\u0352\0\u04e2\0\u0514"+
    "\0\u0320\0\u0320\0\u0320\0\u0352\0\u0546\0\u0320\0\u0578\0\u05aa"+
    "\0\u05dc\0\u0320\0\u060e\0\u0320\0\u0640\0\u0672\0\u0320\0\u0320"+
    "\0\u06a4\0\u06d6\0\u0320\0\u0320\0\u0352\0\u0708\0\u073a\0\u0320"+
    "\0\u076c\0\u0320\0\u0352\0\u05dc\0\u0320\0\u0352\0\u079e\0\u07d0"+
    "\0\u0802\0\u0320\0\u0834\0\u0866\0\u0898\0\u08ca\0\u08fc\0\u092e"+
    "\0\u0960\0\u0992\0\u09c4\0\u0320\0\u041a\0\u044c\0\u09f6\0\u0a28"+
    "\0\u0a5a\0\u0a8c\0\u0320\0\u0320\0\u0abe\0\u0af0\0\u0b22\0\u0320"+
    "\0\u0b54\0\u0b86\0\u0320\0\u0bb8\0\u0bea\0\u0c1c\0\u0c4e\0\u0c80"+
    "\0\u0cb2\0\u0ce4\0\u0d16\0\u0d48\0\u0d7a\0\u0dac\0\u0320\0\u0dde"+
    "\0\u0320\0\u0320\0\u0e10\0\u0e42\0\u0320\0\u0e74\0\u0320\0\u0ea6"+
    "\0\u0320\0\u0ed8\0\u0f0a\0\u0f3c\0\u0f6e\0\u0320\0\u0fa0\0\u0fd2"+
    "\0\u0320";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[121];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\17\1\20\2\17\2\21\1\22\10\17\1\23\23\17"+
    "\1\24\15\17\1\25\1\26\1\20\1\26\1\27\2\26"+
    "\1\30\1\31\10\26\1\32\7\26\1\33\4\26\1\34"+
    "\16\26\1\34\4\26\1\20\6\35\1\36\2\35\1\37"+
    "\5\35\1\40\1\41\21\35\1\42\17\35\1\43\1\20"+
    "\4\43\1\44\6\43\1\45\1\43\1\46\2\43\20\45"+
    "\3\43\14\45\1\20\1\43\1\20\4\43\1\44\6\43"+
    "\1\45\1\43\1\47\2\43\20\45\3\43\14\45\1\20"+
    "\1\43\1\50\4\43\1\44\4\43\1\51\4\43\1\52"+
    "\40\43\1\50\1\53\1\20\1\53\1\54\3\53\1\54"+
    "\3\53\1\51\3\53\1\43\1\52\40\53\1\55\1\56"+
    "\1\20\1\56\1\57\3\56\1\60\3\56\1\61\4\56"+
    "\1\52\40\56\1\62\3\63\1\64\2\63\1\65\34\63"+
    "\1\66\24\63\1\65\1\64\33\63\1\66\16\63\20\67"+
    "\1\70\1\71\40\67\1\72\1\20\4\72\1\73\4\72"+
    "\1\74\3\72\1\46\1\52\40\72\1\20\6\75\1\76"+
    "\2\75\1\77\10\75\20\100\2\75\1\101\14\100\7\75"+
    "\1\76\2\75\1\77\10\75\20\100\2\75\1\102\14\100"+
    "\1\75\1\17\1\0\2\17\3\0\10\17\1\0\23\17"+
    "\1\24\16\17\1\0\1\20\57\0\1\20\66\0\1\103"+
    "\10\0\1\104\4\0\20\104\3\0\1\105\1\104\2\106"+
    "\1\104\1\107\2\104\1\110\3\104\3\0\1\111\10\0"+
    "\1\112\1\0\1\113\3\0\1\114\20\113\3\0\14\113"+
    "\1\0\1\17\1\0\4\17\1\0\10\17\1\0\23\17"+
    "\1\24\17\17\1\20\2\17\3\0\10\17\1\0\23\17"+
    "\1\24\15\17\1\25\3\115\1\63\56\115\7\116\1\63"+
    "\52\116\36\0\1\117\20\0\1\117\41\0\1\120\20\0"+
    "\1\120\12\0\1\121\52\0\1\122\70\0\2\45\1\0"+
    "\2\45\4\0\20\45\3\0\14\45\14\0\1\123\47\0"+
    "\1\50\57\0\1\50\20\0\1\124\41\0\1\53\1\0"+
    "\1\53\1\0\3\53\1\0\3\53\1\0\3\53\2\0"+
    "\42\53\1\20\1\53\1\0\3\53\1\0\3\53\1\0"+
    "\3\53\2\0\40\53\1\55\1\56\1\0\11\56\1\125"+
    "\4\56\1\0\42\56\1\0\11\56\1\125\4\56\1\124"+
    "\42\56\1\20\11\56\1\125\4\56\1\0\40\56\1\62"+
    "\5\0\1\63\54\0\20\67\1\0\1\126\60\67\1\70"+
    "\41\67\11\0\1\127\51\0\2\100\3\0\1\100\1\0"+
    "\1\100\1\0\1\100\1\0\1\100\5\0\20\100\3\0"+
    "\15\100\20\0\1\130\55\0\1\131\23\0\1\132\32\0"+
    "\2\104\1\0\2\104\1\133\3\0\20\104\3\0\14\104"+
    "\12\0\2\104\1\0\2\104\1\133\3\0\20\104\3\0"+
    "\4\104\1\134\2\104\1\135\4\104\12\0\2\104\1\0"+
    "\2\104\1\133\3\0\20\104\3\0\12\104\1\136\1\104"+
    "\12\0\2\104\1\0\2\104\1\133\3\0\20\104\3\0"+
    "\1\104\1\137\12\104\12\0\2\104\1\0\2\104\1\133"+
    "\3\0\20\104\3\0\13\104\1\140\12\0\1\141\13\0"+
    "\1\142\51\0\1\143\4\0\20\143\3\0\14\143\12\0"+
    "\2\113\1\0\2\113\4\0\20\113\3\0\14\113\34\0"+
    "\1\144\15\0\1\144\33\0\1\145\22\0\1\145\15\0"+
    "\1\146\15\0\1\147\52\0\1\150\30\0\1\151\17\0"+
    "\13\56\1\125\4\56\1\0\41\56\20\67\1\0\41\67"+
    "\20\0\1\147\55\0\1\131\1\0\1\152\57\0\1\153"+
    "\5\0\5\153\16\0\2\153\24\0\2\104\1\0\2\104"+
    "\1\133\3\0\20\104\3\0\7\104\1\136\4\104\12\0"+
    "\2\104\1\0\2\104\1\133\3\0\20\104\3\0\6\104"+
    "\1\154\5\104\12\0\2\104\1\0\2\104\1\152\3\0"+
    "\20\104\3\0\14\104\12\0\2\104\1\0\2\104\1\133"+
    "\3\0\20\104\3\0\11\104\1\134\2\104\12\0\2\104"+
    "\1\0\2\104\1\133\3\0\20\104\3\0\6\104\1\106"+
    "\5\104\12\0\1\155\104\0\1\156\16\0\1\156\17\0"+
    "\2\143\1\0\2\143\4\0\20\143\3\0\14\143\33\0"+
    "\1\157\15\0\1\157\43\0\1\160\15\0\1\160\31\0"+
    "\1\161\52\0\1\162\64\0\1\153\1\0\1\152\3\0"+
    "\5\153\16\0\2\153\24\0\2\104\1\0\2\104\1\133"+
    "\3\0\20\104\3\0\11\104\1\136\2\104\25\0\1\163"+
    "\66\0\1\164\41\0\1\146\6\0\1\147\77\0\1\165"+
    "\20\0\1\165\26\0\1\166\76\0\1\167\55\0\1\170"+
    "\16\0\1\170\33\0\1\171\33\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[4100];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\1\11\0\1\1\3\0\2\1\1\11\4\1\1\11"+
    "\3\1\1\11\2\1\1\11\3\1\3\11\2\1\1\11"+
    "\3\1\1\11\1\1\1\11\2\1\2\11\2\1\2\11"+
    "\3\1\1\11\1\1\1\11\2\1\1\11\4\1\1\11"+
    "\7\0\2\1\1\11\6\0\2\11\1\1\2\0\1\11"+
    "\2\0\1\11\7\0\1\1\3\0\1\11\1\0\2\11"+
    "\2\0\1\11\1\0\1\11\1\0\1\11\1\1\3\0"+
    "\1\11\2\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[121];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
  public final int getTokenStart() {
      return (int) yychar;
  }

  public final int getTokenEnd() {
      return getTokenStart() + yylength();
  }


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public HtmlLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  @NotNull
  public HtmlToken advance() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
              {
                return HtmlToken.EOF;
              }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return HtmlToken.XML_DATA_CHARACTERS;
            }
            // fall through
          case 40: break;
          case 2:
            { return HtmlToken.XML_PI_TARGET;
            }
            // fall through
          case 41: break;
          case 3:
            { return HtmlToken.WHITESPACE;
            }
            // fall through
          case 42: break;
          case 4:
            { return HtmlToken.BAD_CHARACTER;
            }
            // fall through
          case 43: break;
          case 5:
            { yybegin(YYINITIAL); return HtmlToken.XML_DOCTYPE_END;
            }
            // fall through
          case 44: break;
          case 6:
            { return HtmlToken.XML_COMMENT_CHARACTERS;
            }
            // fall through
          case 45: break;
          case 7:
            { int loc = getTokenStart();
          char prev = zzBuffer[loc - 1];
          char prevPrev = zzBuffer[loc - 2];
          if (prev == '-' && prevPrev == '-') {
              yybegin(YYINITIAL); return HtmlToken.BAD_CHARACTER;
          }
          return HtmlToken.XML_COMMENT_CHARACTERS;
            }
            // fall through
          case 46: break;
          case 8:
            { yybegin(C_COMMENT_START); return HtmlToken.XML_CONDITIONAL_COMMENT_START;
            }
            // fall through
          case 47: break;
          case 9:
            { yybegin(YYINITIAL); yypushback(1); break;
            }
            // fall through
          case 48: break;
          case 10:
            { yybegin(BEFORE_TAG_ATTRIBUTES); return HtmlToken.XML_TAG_NAME;
            }
            // fall through
          case 49: break;
          case 11:
            { return HtmlToken.XML_START_TAG_START;
            }
            // fall through
          case 50: break;
          case 12:
            { yybegin(TAG_ATTRIBUTES); return HtmlToken.WHITESPACE;
            }
            // fall through
          case 51: break;
          case 13:
            { yybegin(YYINITIAL); return HtmlToken.XML_TAG_END;
            }
            // fall through
          case 52: break;
          case 14:
            { return HtmlToken.XML_ATTR_NAME;
            }
            // fall through
          case 53: break;
          case 15:
            { yybegin(ATTRIBUTE_VALUE_START); yypushback(1);
            }
            // fall through
          case 54: break;
          case 16:
            { yybegin(TAG_ATTRIBUTES); return HtmlToken.XML_ATTRIBUTE_VALUE_TOKEN;
            }
            // fall through
          case 55: break;
          case 17:
            { yybegin(ATTRIBUTE_VALUE_DQ); return HtmlToken.XML_ATTRIBUTE_VALUE_START_DELIMITER;
            }
            // fall through
          case 56: break;
          case 18:
            { yybegin(ATTRIBUTE_VALUE_SQ); return HtmlToken.XML_ATTRIBUTE_VALUE_START_DELIMITER;
            }
            // fall through
          case 57: break;
          case 19:
            { return HtmlToken.XML_ATTRIBUTE_VALUE_TOKEN;
            }
            // fall through
          case 58: break;
          case 20:
            { yybegin(TAG_ATTRIBUTES); return HtmlToken.XML_ATTRIBUTE_VALUE_END_DELIMITER;
            }
            // fall through
          case 59: break;
          case 21:
            { yybegin(YYINITIAL); return HtmlToken.XML_PI_END;
            }
            // fall through
          case 60: break;
          case 22:
            { return HtmlToken.XML_TAG_CHARACTERS;
            }
            // fall through
          case 61: break;
          case 23:
            { yybegin(COMMENT); return HtmlToken.XML_COMMENT_CHARACTERS;
            }
            // fall through
          case 62: break;
          case 24:
            { yybegin(COMMENT); return HtmlToken.XML_CONDITIONAL_COMMENT_END;
            }
            // fall through
          case 63: break;
          case 25:
            { return HtmlToken.XML_END_TAG_START;
            }
            // fall through
          case 64: break;
          case 26:
            { yybegin(START_TAG_NAME); yypushback(yylength());
            }
            // fall through
          case 65: break;
          case 27:
            { yybegin(PROCESSING_INSTRUCTION); return HtmlToken.XML_PI_START;
            }
            // fall through
          case 66: break;
          case 28:
            { yybegin(YYINITIAL); return HtmlToken.XML_EMPTY_ELEMENT_END;
            }
            // fall through
          case 67: break;
          case 29:
            { yybegin(COMMENT); return HtmlToken.XML_CONDITIONAL_COMMENT_START_END;
            }
            // fall through
          case 68: break;
          case 30:
            { return HtmlToken.XML_ENTITY_REF_TOKEN;
            }
            // fall through
          case 69: break;
          case 31:
            { yybegin(END_TAG_NAME); yypushback(yylength());
            }
            // fall through
          case 70: break;
          case 32:
            { yybegin(YYINITIAL); return HtmlToken.XML_COMMENT_END;
            }
            // fall through
          case 71: break;
          case 33:
            { yybegin(C_COMMENT_END); return HtmlToken.XML_CONDITIONAL_COMMENT_END_START;
            }
            // fall through
          case 72: break;
          case 34:
            { return HtmlToken.XML_CHAR_ENTITY_REF;
            }
            // fall through
          case 73: break;
          case 35:
            { yybegin(COMMENT); return HtmlToken.XML_COMMENT_START;
            }
            // fall through
          case 74: break;
          case 36:
            { return HtmlToken.XML_TAG_NAME;
            }
            // fall through
          case 75: break;
          case 37:
            { yybegin(YYINITIAL); return HtmlToken.BAD_CHARACTER;
            }
            // fall through
          case 76: break;
          case 38:
            { return HtmlToken.XML_DOCTYPE_PUBLIC;
            }
            // fall through
          case 77: break;
          case 39:
            { yybegin(DOC_TYPE); return HtmlToken.XML_DOCTYPE_START;
            }
            // fall through
          case 78: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
