/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.php.lexer

enum class PhpToken {
    INTEGER_LITERAL,
    FLOAT_LITERAL,
    DOUBLE_LITERAL,
    VARIABLE_LITERAL,

    ABSTRACT,
    AS,
    BREAK,
    CASE,
    CATCH,
    CONST,
    CLASS,
    CONTINUE,
    DEBUGGER,
    DEFAULT,
    DELETE,
    DO,
    EACH,
    ELSE,
    ELSEIF,
    ENUM,
    EXPORT,
    EXTENDS,
    FINAL,
    FINALLY,
    FN,
    FOR,
    FOREACH,
    FUNCTION,
    GOTO,
    GLOBAL,
    IF,
    IMPLEMENTS,
    IMPORT,
    IN,
    INCLUDE,
    INCLUDE_ONCE,
    INSTANCEOF,
    INSTEADOF,
    INTERFACE,
    LET,
    NAMESPACE,
    NATIVE,
    NEW,
    PACKAGE,
    PARENT,
    PRIVATE,
    PROTECTED,
    PUBLIC,
    RETURN,
    SELF,
    STATIC,
    SUPER,
    SWITCH,
    SYNCHRONIZED,
    THIS,
    THROW,
    THROWS,
    TYPEOF,
    TRANSIENT,
    TRY,
    VAR,
    VOID,
    VOLATILE,
    WHILE,
    WITH,

    BOOLEAN,
    BYTE,
    CHAR,
    DOUBLE,
    FLOAT,
    INT,
    LONG,
    SHORT,

    TRUE,
    FALSE,
    NULL,
    NAN,
    INFINITY,

    ARRAY,
    DIE,
    ECHO,
    EMPTY,
    EVAL,
    EXIT,
    PARSEINT,
    PARSEFLOAT,
    PRINT,
    ESCAPE,
    UNESCAPE,
    ISNAN,
    ISFINITE,

    PLUS,
    MINUS,
    LTEQ,
    XOR,
    PLUSPLUS,
    LT,
    MULT,
    GTEQ,
    MOD,
    MINUSMINUS,
    GT,
    DIV,
    NOTEQ,
    QUEST,
    GTGT,
    NOT,
    AND,
    EQEQ,
    COLON,
    TILDA,
    OROR,
    ANDAND,
    GTGTGT,

    EQ,
    MINUSEQ,
    MULTEQ,
    DIVEQ,
    OREQ,
    ANDEQ,
    XOREQ,
    PLUSEQ,
    MODEQ,
    LTLTEQ,
    GTGTEQ,
    GTGTGTEQ,

    LPAREN,
    RPAREN,
    LBRACE,
    RBRACE,
    LBRACK,
    RBRACK,
    SEMICOLON,
    COMMA,
    DOT,

    DOUBLE_QUOTED_STRING,
    SINGLE_QUOTED_STRING,

    LINE_COMMENT,
    BLOCK_COMMENT,

    IDENTIFIER,
    WHITESPACE,
    BAD_CHARACTER,
    EOF
}