/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.ruby.lexer;

import org.jetbrains.annotations.NotNull;

@SuppressWarnings("all")

/**
 * This class is a scanner generated by
 * <a href="http://www.jflex.de/">JFlex</a> 1.8.2
 * from the specification file <tt>ruby.flex</tt>
 */
public class RubyLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0, 0
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\1\u0200\1\u0300\1\u0400\1\u0500\1\u0600\1\u0700"+
    "\1\u0800\1\u0900\1\u0a00\1\u0b00\1\u0c00\1\u0d00\1\u0e00\1\u0f00"+
    "\1\u1000\1\u0100\1\u1100\1\u1200\1\u1300\1\u0100\1\u1400\1\u1500"+
    "\1\u1600\1\u1700\1\u1800\1\u1900\1\u1a00\1\u1b00\1\u0100\1\u1c00"+
    "\1\u1d00\1\u1e00\2\u1f00\1\u2000\7\u1f00\1\u2100\1\u2200\1\u2300"+
    "\1\u1f00\1\u2400\1\u2500\2\u1f00\31\u0100\1\u2600\121\u0100\1\u2700"+
    "\4\u0100\1\u2800\1\u0100\1\u2900\1\u2a00\1\u2b00\1\u2c00\1\u2d00"+
    "\1\u2e00\53\u0100\1\u2f00\10\u3000\31\u1f00\1\u0100\1\u3100\1\u3200"+
    "\1\u0100\1\u3300\1\u3400\1\u3500\1\u3600\1\u3700\1\u3800\1\u3900"+
    "\1\u3a00\1\u3b00\1\u0100\1\u3c00\1\u3d00\1\u3e00\1\u3f00\1\u4000"+
    "\1\u4100\1\u4200\1\u1f00\1\u4300\1\u4400\1\u4500\1\u4600\1\u4700"+
    "\1\u4800\1\u4900\1\u4a00\1\u4b00\1\u4c00\1\u4d00\1\u4e00\1\u1f00"+
    "\1\u4f00\1\u5000\1\u5100\1\u1f00\3\u0100\1\u5200\1\u5300\1\u5400"+
    "\12\u1f00\4\u0100\1\u5500\17\u1f00\2\u0100\1\u5600\41\u1f00\2\u0100"+
    "\1\u5700\1\u5800\2\u1f00\1\u5900\1\u5a00\27\u0100\1\u5b00\2\u0100"+
    "\1\u5c00\45\u1f00\1\u0100\1\u5d00\1\u5e00\11\u1f00\1\u5f00\24\u1f00"+
    "\1\u6000\1\u6100\1\u1f00\1\u6200\1\u6300\1\u6400\1\u6500\2\u1f00"+
    "\1\u6600\5\u1f00\1\u6700\1\u6800\1\u6900\5\u1f00\1\u6a00\1\u6b00"+
    "\4\u1f00\1\u6c00\2\u1f00\1\u6d00\16\u1f00\246\u0100\1\u6e00\20\u0100"+
    "\1\u6f00\1\u7000\25\u0100\1\u7100\34\u0100\1\u7200\14\u1f00\2\u0100"+
    "\1\u7300\u0b05\u1f00\1\u7400\1\u7500\u02fe\u1f00";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\3\1\4\1\5\16\0\4\6"+
    "\1\1\1\7\1\10\1\11\1\12\1\13\1\14\1\15"+
    "\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25"+
    "\1\26\11\27\1\30\1\31\1\32\1\33\1\34\1\35"+
    "\1\36\1\37\1\40\1\41\1\42\1\43\1\44\1\45"+
    "\1\46\1\47\2\46\1\50\1\46\1\51\1\52\1\53"+
    "\1\46\1\54\1\46\1\55\3\46\1\56\2\46\1\57"+
    "\1\60\1\61\1\62\1\63\1\64\1\65\1\66\1\67"+
    "\1\70\1\71\1\72\1\73\1\74\1\75\1\46\1\76"+
    "\1\77\1\100\1\101\1\102\1\103\1\104\1\105\1\106"+
    "\1\107\1\110\1\111\1\112\1\113\1\114\1\46\1\115"+
    "\1\116\1\117\1\120\6\0\1\121\32\0\1\122\1\6"+
    "\4\12\4\6\1\46\2\6\1\0\7\6\1\46\4\6"+
    "\1\46\5\6\27\46\1\6\37\46\1\6\u01ca\46\4\6"+
    "\14\46\16\6\5\46\7\6\1\46\1\6\1\46\21\6"+
    "\160\123\5\46\1\6\2\46\2\6\4\46\1\6\1\46"+
    "\6\6\1\46\1\6\3\46\1\6\1\46\1\6\24\46"+
    "\1\6\123\46\1\6\213\46\1\6\5\123\2\124\246\46"+
    "\1\6\46\46\2\6\1\46\6\6\1\124\47\46\1\124"+
    "\6\6\1\12\1\6\55\123\1\6\1\123\1\6\2\123"+
    "\1\6\2\123\1\6\1\123\10\6\33\46\4\6\1\124"+
    "\3\46\15\6\6\0\5\6\1\12\4\6\13\123\1\6"+
    "\1\0\3\6\53\46\37\123\4\6\2\46\1\123\143\46"+
    "\1\6\1\46\7\123\1\0\1\6\6\123\2\46\2\123"+
    "\1\6\4\123\2\46\12\123\3\46\2\6\1\46\17\6"+
    "\1\0\1\46\1\123\36\46\33\123\2\6\131\46\13\123"+
    "\1\46\16\6\12\123\41\46\11\123\2\46\4\6\1\46"+
    "\2\6\1\124\2\6\26\46\4\123\1\46\11\123\1\46"+
    "\3\123\1\46\5\123\22\6\31\46\3\123\4\6\13\46"+
    "\65\6\25\46\1\6\10\46\25\6\1\124\16\123\1\0"+
    "\41\123\66\46\3\123\1\46\22\123\1\46\7\123\12\46"+
    "\2\123\2\6\12\123\1\6\20\46\3\123\1\6\10\46"+
    "\2\6\2\46\2\6\26\46\1\6\7\46\1\6\1\46"+
    "\3\6\4\46\2\6\1\123\1\46\7\123\2\6\2\123"+
    "\2\6\3\123\1\46\10\6\1\123\4\6\2\46\1\6"+
    "\3\46\2\123\2\6\12\123\2\46\2\12\7\6\1\12"+
    "\1\46\1\6\1\124\2\6\3\123\1\6\6\46\4\6"+
    "\2\46\2\6\26\46\1\6\7\46\1\6\2\46\1\6"+
    "\2\46\1\6\2\46\2\6\1\123\1\6\5\123\4\6"+
    "\2\123\2\6\3\123\3\6\1\123\7\6\4\46\1\6"+
    "\1\46\7\6\14\123\3\46\1\123\13\6\3\123\1\6"+
    "\11\46\1\6\3\46\1\6\26\46\1\6\7\46\1\6"+
    "\2\46\1\6\5\46\2\6\1\123\1\46\10\123\1\6"+
    "\3\123\1\6\3\123\2\6\1\46\17\6\2\46\2\123"+
    "\2\6\12\123\1\6\1\12\7\6\1\46\6\123\1\6"+
    "\3\123\1\6\10\46\2\6\2\46\2\6\26\46\1\6"+
    "\7\46\1\6\2\46\1\6\5\46\2\6\1\123\1\46"+
    "\7\123\2\6\2\123\2\6\3\123\10\6\2\123\4\6"+
    "\2\46\1\6\3\46\2\123\2\6\12\123\1\6\1\46"+
    "\20\6\1\123\1\46\1\6\6\46\3\6\3\46\1\6"+
    "\4\46\3\6\2\46\1\6\1\46\1\6\2\46\3\6"+
    "\2\46\3\6\3\46\3\6\14\46\4\6\5\123\3\6"+
    "\3\123\1\6\4\123\2\6\1\46\6\6\1\123\16\6"+
    "\12\123\11\6\1\12\6\6\4\123\1\124\10\46\1\6"+
    "\3\46\1\6\27\46\1\6\20\46\3\6\1\46\7\123"+
    "\1\6\3\123\1\6\4\123\7\6\2\123\1\6\3\46"+
    "\5\6\2\46\2\123\2\6\12\123\20\6\1\46\3\123"+
    "\1\6\10\46\1\6\3\46\1\6\27\46\1\6\12\46"+
    "\1\6\5\46\2\6\1\123\1\46\7\123\1\6\3\123"+
    "\1\6\4\123\7\6\2\123\7\6\1\46\1\6\2\46"+
    "\2\123\2\6\12\123\1\6\2\46\15\6\4\123\1\6"+
    "\10\46\1\6\3\46\1\6\51\46\2\123\1\46\7\123"+
    "\1\6\3\123\1\6\4\123\1\46\5\6\3\46\1\123"+
    "\7\6\3\46\2\123\2\6\12\123\12\6\6\46\2\6"+
    "\2\123\1\6\22\46\3\6\30\46\1\6\11\46\1\6"+
    "\1\46\2\6\7\46\3\6\1\123\4\6\6\123\1\6"+
    "\1\123\1\6\10\123\6\6\12\123\2\6\2\123\15\6"+
    "\60\46\1\123\2\46\7\123\4\6\1\12\7\46\10\123"+
    "\1\6\12\123\47\6\2\46\1\6\1\46\1\6\1\124"+
    "\2\46\1\124\1\46\1\6\1\124\1\46\6\124\4\46"+
    "\1\124\7\46\1\124\3\46\1\6\1\46\1\6\1\46"+
    "\2\124\2\46\1\124\4\46\1\123\2\46\6\123\1\124"+
    "\2\123\1\46\2\6\5\46\1\6\1\46\1\6\6\123"+
    "\2\6\12\123\2\6\4\46\40\6\1\46\27\6\2\123"+
    "\6\6\12\123\13\6\1\123\1\6\1\123\1\6\1\123"+
    "\4\6\2\123\10\46\1\6\44\46\4\6\24\123\1\6"+
    "\2\123\5\46\13\123\1\6\44\123\11\6\1\123\71\6"+
    "\53\46\24\123\1\46\12\123\6\6\6\46\4\123\4\46"+
    "\3\123\1\46\3\123\2\46\7\123\3\46\4\123\15\46"+
    "\14\123\1\46\17\123\2\6\46\46\1\6\1\46\5\6"+
    "\1\46\2\6\53\46\1\6\115\46\1\6\4\46\2\6"+
    "\7\46\1\6\1\46\1\6\4\46\2\6\51\46\1\6"+
    "\4\46\2\6\41\46\1\6\4\46\2\6\7\46\1\6"+
    "\1\46\1\6\4\46\2\6\17\46\1\6\71\46\1\6"+
    "\4\46\2\6\103\46\2\6\3\123\40\6\20\46\20\6"+
    "\126\46\2\6\6\46\3\6\u016c\46\2\6\21\46\1\122"+
    "\32\46\5\6\113\46\3\6\13\46\7\6\15\46\1\6"+
    "\4\46\3\123\13\6\22\46\3\123\13\6\22\46\2\123"+
    "\14\6\15\46\1\6\3\46\1\6\2\123\14\6\64\46"+
    "\40\123\3\6\1\46\3\6\1\12\1\46\1\123\2\6"+
    "\12\123\41\6\3\123\1\0\1\6\12\123\6\6\130\46"+
    "\1\124\7\6\5\46\2\123\42\46\1\123\1\46\5\6"+
    "\106\46\12\6\37\46\1\6\14\123\4\6\14\123\12\6"+
    "\12\123\36\46\2\6\5\46\13\6\54\46\4\6\32\46"+
    "\6\6\12\123\46\6\27\46\5\123\4\6\65\46\12\123"+
    "\1\6\35\123\2\6\13\123\6\6\12\123\15\6\1\46"+
    "\10\6\16\123\1\124\101\6\5\123\57\46\21\123\7\46"+
    "\4\6\12\123\21\6\11\123\14\6\3\123\36\46\15\123"+
    "\2\46\12\123\54\46\16\123\14\6\44\46\24\123\10\6"+
    "\12\123\3\6\3\46\12\123\44\46\2\6\11\46\7\6"+
    "\53\124\2\6\3\124\20\6\3\123\1\6\25\123\4\46"+
    "\1\123\4\46\3\123\2\46\3\123\1\124\5\6\300\46"+
    "\72\123\1\6\5\123\26\46\2\6\6\46\2\6\46\46"+
    "\2\6\6\46\2\6\10\46\1\6\1\46\1\6\1\46"+
    "\1\6\1\46\1\6\37\46\2\6\65\46\1\6\7\46"+
    "\1\6\1\46\3\6\3\46\1\6\7\46\3\6\4\46"+
    "\2\6\6\46\4\6\15\46\5\6\3\46\1\6\7\46"+
    "\3\6\13\122\5\0\30\6\2\3\5\0\1\122\17\6"+
    "\2\46\23\6\1\46\12\6\1\122\5\0\1\6\12\0"+
    "\1\6\1\46\15\6\1\46\20\6\15\46\3\6\40\12"+
    "\20\6\15\123\4\124\1\123\3\124\14\123\21\6\1\46"+
    "\4\6\1\46\2\6\12\46\1\6\1\46\3\6\5\46"+
    "\6\6\1\46\1\6\1\46\1\6\1\46\1\6\4\46"+
    "\1\6\13\46\2\6\4\46\5\6\5\46\4\6\1\46"+
    "\21\6\51\46\u022d\6\64\124\26\6\57\46\1\6\57\46"+
    "\1\6\205\46\6\6\4\46\3\123\2\46\14\6\46\46"+
    "\1\6\1\46\5\6\1\46\2\6\70\46\7\6\1\46"+
    "\17\6\1\123\27\46\11\6\7\46\1\6\7\46\1\6"+
    "\7\46\1\6\7\46\1\6\7\46\1\6\7\46\1\6"+
    "\7\46\1\6\7\46\1\6\40\123\57\6\1\46\320\6"+
    "\1\122\4\6\3\46\31\6\11\46\6\123\1\6\5\46"+
    "\2\6\5\46\4\6\126\46\2\6\2\123\2\6\3\46"+
    "\1\6\132\46\1\6\4\46\5\6\52\46\1\124\1\6"+
    "\136\46\21\6\33\46\65\6\306\46\112\6\353\46\5\124"+
    "\20\6\215\46\103\6\56\46\2\6\15\46\3\6\20\46"+
    "\12\123\2\46\24\6\57\46\1\123\3\124\1\6\12\123"+
    "\1\6\37\46\2\123\120\46\2\123\45\6\11\46\2\6"+
    "\147\46\2\6\44\46\1\124\10\46\10\124\2\6\5\124"+
    "\60\6\13\46\1\123\3\46\1\123\4\46\1\123\27\46"+
    "\5\123\20\6\1\12\7\6\64\46\14\6\2\123\62\46"+
    "\22\123\12\6\12\123\6\6\22\123\6\46\3\6\1\46"+
    "\1\6\1\46\2\124\12\123\34\46\10\123\2\6\27\46"+
    "\15\123\14\6\35\46\3\6\4\123\57\46\16\123\16\6"+
    "\1\46\12\123\6\6\5\46\1\123\12\46\12\123\5\46"+
    "\1\6\51\46\16\123\11\6\3\46\1\123\10\46\2\123"+
    "\2\6\12\123\6\6\27\46\3\6\1\46\3\123\62\46"+
    "\1\123\1\46\3\123\2\46\2\123\5\46\2\123\1\46"+
    "\1\123\1\46\30\6\3\46\2\6\13\46\5\123\2\6"+
    "\3\46\2\123\12\6\6\46\2\6\6\46\2\6\6\46"+
    "\11\6\7\46\1\6\7\46\1\6\53\46\1\6\12\46"+
    "\2\124\10\6\163\46\10\123\1\6\2\123\2\6\12\123"+
    "\6\6\244\46\14\6\27\46\4\6\61\46\4\6\u0100\125"+
    "\156\46\2\6\152\46\46\6\7\46\14\6\5\46\5\6"+
    "\1\46\1\123\12\46\1\6\15\46\1\6\5\46\1\6"+
    "\1\46\1\6\2\46\1\6\2\46\1\6\154\46\41\6"+
    "\153\46\22\6\100\46\2\6\66\46\50\6\14\46\1\12"+
    "\3\6\20\123\20\6\20\123\3\6\2\46\30\6\3\46"+
    "\31\6\1\12\6\6\5\46\1\6\207\46\2\6\1\0"+
    "\4\6\1\12\13\6\12\123\7\6\32\46\4\6\1\46"+
    "\1\6\32\46\13\6\131\46\3\6\6\46\2\6\6\46"+
    "\2\6\6\46\2\6\3\46\3\6\2\12\3\6\2\12"+
    "\22\6\3\0\4\6\14\46\1\6\32\46\1\6\23\46"+
    "\1\6\2\46\1\6\17\46\2\6\16\46\42\6\173\46"+
    "\105\6\65\46\210\6\1\123\202\6\35\46\3\6\61\46"+
    "\17\6\1\123\37\6\40\46\15\6\36\46\5\6\46\46"+
    "\5\123\5\6\36\46\2\6\44\46\4\6\10\46\1\6"+
    "\5\46\52\6\236\46\2\6\12\123\6\6\44\46\4\6"+
    "\44\46\4\6\50\46\10\6\64\46\234\6\67\46\11\6"+
    "\26\46\12\6\10\46\230\6\6\46\2\6\1\46\1\6"+
    "\54\46\1\6\2\46\3\6\1\46\2\6\27\46\12\6"+
    "\27\46\11\6\37\46\101\6\23\46\1\6\2\46\12\6"+
    "\26\46\12\6\32\46\106\6\70\46\6\6\2\46\100\6"+
    "\1\46\3\123\1\6\2\123\5\6\4\123\4\46\1\6"+
    "\3\46\1\6\33\46\2\124\2\6\3\123\4\6\1\123"+
    "\40\6\35\46\3\6\35\46\43\6\10\46\1\6\34\46"+
    "\2\123\31\6\66\46\12\6\26\46\12\6\23\46\15\6"+
    "\22\46\156\6\111\46\67\6\63\46\15\6\63\46\15\6"+
    "\50\124\10\6\12\124\306\6\35\124\12\6\1\124\10\6"+
    "\41\124\217\6\27\124\11\6\3\123\65\46\17\123\37\6"+
    "\12\123\17\6\4\123\55\46\13\123\2\6\1\0\22\6"+
    "\31\46\7\6\12\123\6\6\3\123\44\46\16\123\1\6"+
    "\12\123\4\6\3\124\11\6\43\46\1\123\2\6\1\46"+
    "\11\6\3\123\60\46\16\123\4\46\4\6\1\124\3\123"+
    "\3\6\12\123\1\46\1\6\1\46\43\6\22\46\1\6"+
    "\31\46\14\123\6\6\1\123\101\6\7\46\1\6\1\46"+
    "\1\6\4\46\1\6\17\46\1\6\12\46\7\6\57\46"+
    "\14\123\5\6\12\123\6\6\4\123\1\6\10\46\2\6"+
    "\2\46\2\6\26\46\1\6\7\46\1\6\2\46\1\6"+
    "\5\46\1\6\1\124\1\123\1\46\7\123\2\6\2\123"+
    "\2\6\3\123\2\6\1\46\6\6\1\123\5\6\5\46"+
    "\2\123\2\6\7\123\3\6\5\123\213\6\65\46\22\123"+
    "\4\46\5\6\12\123\4\6\2\124\40\6\60\46\24\123"+
    "\2\46\1\6\1\46\10\6\12\123\246\6\57\46\7\123"+
    "\2\6\11\123\27\6\4\46\2\123\42\6\60\46\21\123"+
    "\3\6\1\46\13\6\12\123\46\6\53\46\15\123\1\124"+
    "\7\6\12\123\66\6\32\46\1\124\2\6\17\123\4\6"+
    "\12\123\306\6\73\124\145\6\100\46\12\123\25\6\1\46"+
    "\240\6\10\124\2\6\56\124\2\6\10\124\1\6\2\124"+
    "\33\6\1\46\12\123\50\46\7\123\1\46\4\123\10\6"+
    "\1\123\10\6\1\46\13\123\50\46\2\124\4\46\20\123"+
    "\3\6\1\124\42\6\71\46\7\6\11\46\1\6\45\46"+
    "\10\123\1\6\10\123\1\46\17\6\12\123\30\6\36\46"+
    "\2\6\26\123\1\6\16\123\111\6\7\46\1\6\2\46"+
    "\1\6\46\46\6\123\3\6\1\123\1\6\2\123\1\6"+
    "\7\123\1\46\1\123\10\6\12\123\6\6\6\124\1\6"+
    "\2\124\1\6\45\124\1\6\2\124\1\6\6\124\7\6"+
    "\12\124\u0136\6\27\124\11\6\232\46\146\6\157\46\21\6"+
    "\304\46\274\6\57\46\321\6\107\46\271\6\71\46\7\6"+
    "\37\46\1\6\12\123\146\6\36\46\2\6\5\123\13\6"+
    "\60\46\7\123\11\6\4\46\14\6\12\123\11\6\25\46"+
    "\5\6\23\46\260\6\100\124\200\6\105\46\6\124\4\6"+
    "\1\124\1\46\56\123\11\124\7\6\4\123\15\46\100\6"+
    "\2\46\1\6\1\124\34\6\355\46\13\124\10\6\363\46"+
    "\15\6\37\46\61\6\3\124\21\6\4\124\10\6\u018c\46"+
    "\4\6\153\46\5\6\15\46\3\6\11\46\7\6\12\46"+
    "\3\6\2\123\1\6\4\0\301\6\5\123\3\6\6\123"+
    "\10\0\10\123\2\6\7\123\36\6\4\123\224\6\3\123"+
    "\273\6\125\46\1\6\107\46\1\6\2\46\2\6\1\46"+
    "\2\6\2\46\2\6\4\46\1\6\14\46\1\6\1\46"+
    "\1\6\7\46\1\6\101\46\1\6\4\46\2\6\10\46"+
    "\1\6\7\46\1\6\34\46\1\6\4\46\1\6\5\46"+
    "\1\6\1\46\3\6\7\46\1\6\u0154\46\2\6\31\46"+
    "\1\6\31\46\1\6\37\46\1\6\31\46\1\6\37\46"+
    "\1\6\31\46\1\6\37\46\1\6\31\46\1\6\37\46"+
    "\1\6\31\46\1\6\10\46\2\6\151\123\4\6\62\123"+
    "\10\6\1\123\16\6\1\123\26\6\5\123\1\6\17\123"+
    "\120\6\7\123\1\6\21\123\2\6\7\123\1\6\2\123"+
    "\1\6\5\123\325\6\55\124\3\6\16\124\2\6\12\124"+
    "\4\6\1\124\u0171\6\72\124\6\6\305\46\13\6\7\123"+
    "\51\6\104\46\7\123\1\124\4\6\12\123\246\6\4\46"+
    "\1\6\33\46\1\6\2\46\1\6\1\46\2\6\1\46"+
    "\1\6\12\46\1\6\4\46\1\6\1\46\1\6\1\46"+
    "\6\6\1\46\4\6\1\46\1\6\1\46\1\6\1\46"+
    "\1\6\3\46\1\6\2\46\1\6\1\46\2\6\1\46"+
    "\1\6\1\46\1\6\1\46\1\6\1\46\1\6\1\46"+
    "\1\6\2\46\1\6\1\46\2\6\4\46\1\6\7\46"+
    "\1\6\4\46\1\6\4\46\1\6\1\46\1\6\12\46"+
    "\1\6\21\46\5\6\3\46\1\6\5\46\1\6\21\46"+
    "\164\6\32\124\6\6\32\124\6\6\32\124\166\6\327\46"+
    "\51\6\65\46\13\6\336\46\2\6\u0182\46\16\6\u0131\46"+
    "\37\6\36\46\343\6\1\0\36\6\140\0\200\6\360\123"+
    "\20\6";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[30208];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\2\2\1\3\1\4\1\5\1\6\1\7"+
    "\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17"+
    "\1\20\1\21\2\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\30\4\6\1\31\1\32\1\33\1\6\1\34\14\6"+
    "\1\35\6\6\1\36\1\37\1\40\1\41\1\42\1\4"+
    "\1\0\2\5\1\43\1\44\1\45\1\11\1\0\1\46"+
    "\1\47\1\50\1\51\1\52\1\53\1\54\1\22\2\53"+
    "\1\55\1\56\1\22\1\57\1\60\1\61\1\62\1\0"+
    "\1\63\1\64\3\6\1\65\1\66\12\6\1\67\10\6"+
    "\1\70\1\71\7\6\1\37\1\35\17\6\1\72\1\73"+
    "\2\4\1\0\1\74\2\11\1\75\1\53\1\0\1\22"+
    "\1\76\1\0\1\77\1\100\1\6\1\101\5\6\1\10"+
    "\6\6\1\102\1\6\1\103\5\6\1\104\7\6\1\105"+
    "\1\3\27\6\1\74\2\0\7\6\1\106\3\6\1\107"+
    "\6\6\1\110\2\6\1\111\5\6\1\112\2\6\1\113"+
    "\1\6\1\114\3\6\1\115\2\6\1\0\4\6\1\116"+
    "\1\117\1\120\1\121\1\6\1\122\1\6\1\123\5\6"+
    "\1\124\1\6\1\125\1\6\1\126\1\6\1\127\1\130"+
    "\1\131\1\0\5\6\1\132\1\133\1\6\1\134\1\135"+
    "\1\136\1\137\5\6\1\0\1\6\1\140\1\141\1\142"+
    "\1\35\1\0\1\6\1\0\1\6\1\137\1\6\1\143";

  private static int [] zzUnpackAction() {
    int [] result = new int[310];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\126\0\126\0\254\0\u0102\0\u0158\0\u01ae\0\u0204"+
    "\0\u025a\0\u02b0\0\u0306\0\126\0\126\0\u035c\0\u03b2\0\126"+
    "\0\u0408\0\u045e\0\u04b4\0\u050a\0\u0560\0\126\0\126\0\u05b6"+
    "\0\u060c\0\u0662\0\u06b8\0\u070e\0\u0764\0\u07ba\0\u0810\0\126"+
    "\0\126\0\u0866\0\u08bc\0\126\0\u0912\0\u0968\0\u09be\0\u0a14"+
    "\0\u0a6a\0\u0ac0\0\u0b16\0\u0b6c\0\u0bc2\0\u0c18\0\u0c6e\0\u0cc4"+
    "\0\u0d1a\0\u0d70\0\u0dc6\0\u0e1c\0\u0e72\0\u0ec8\0\u0f1e\0\126"+
    "\0\u0f74\0\126\0\126\0\126\0\126\0\u0fca\0\u1020\0\u1076"+
    "\0\126\0\126\0\126\0\126\0\u10cc\0\u1122\0\126\0\126"+
    "\0\126\0\126\0\u1178\0\126\0\u11ce\0\126\0\u1224\0\126"+
    "\0\126\0\u127a\0\u12d0\0\126\0\126\0\126\0\u1326\0\126"+
    "\0\u137c\0\u13d2\0\u1428\0\u147e\0\u0204\0\126\0\u14d4\0\u152a"+
    "\0\u1580\0\u15d6\0\u162c\0\u1682\0\u16d8\0\u172e\0\u1784\0\u17da"+
    "\0\u0204\0\u1830\0\u1886\0\u18dc\0\u1932\0\u1988\0\u19de\0\u1a34"+
    "\0\u1a8a\0\u0204\0\u0204\0\u1ae0\0\u1b36\0\u1b8c\0\u1be2\0\u1c38"+
    "\0\u1c8e\0\u1ce4\0\u0204\0\u0204\0\u1d3a\0\u1d90\0\u1de6\0\u1e3c"+
    "\0\u1e92\0\u1ee8\0\u1f3e\0\u1f94\0\u1fea\0\u2040\0\u2096\0\u20ec"+
    "\0\u2142\0\u2198\0\u21ee\0\126\0\126\0\u2244\0\u229a\0\u22f0"+
    "\0\u1020\0\u2346\0\u239c\0\126\0\u23f2\0\u2448\0\u249e\0\126"+
    "\0\u24f4\0\126\0\u0204\0\u254a\0\u0204\0\u25a0\0\u25f6\0\u264c"+
    "\0\u26a2\0\u26f8\0\u0204\0\u274e\0\u27a4\0\u27fa\0\u2850\0\u28a6"+
    "\0\u28fc\0\u2952\0\u29a8\0\u0204\0\u29fe\0\u2a54\0\u2aaa\0\u2b00"+
    "\0\u2b56\0\u2bac\0\u2c02\0\u2c58\0\u2cae\0\u2d04\0\u2d5a\0\u2db0"+
    "\0\u2e06\0\u0204\0\u0204\0\u2e5c\0\u2eb2\0\u2f08\0\u2f5e\0\u2fb4"+
    "\0\u300a\0\u3060\0\u30b6\0\u310c\0\u3162\0\u31b8\0\u320e\0\u3264"+
    "\0\u32ba\0\u3310\0\u3366\0\u33bc\0\u3412\0\u3468\0\u34be\0\u3514"+
    "\0\u356a\0\u35c0\0\126\0\u3616\0\u366c\0\u36c2\0\u3718\0\u376e"+
    "\0\u37c4\0\u381a\0\u3870\0\u38c6\0\u0204\0\u391c\0\u3972\0\u39c8"+
    "\0\u0204\0\u3a1e\0\u3a74\0\u3aca\0\u3b20\0\u3b76\0\u3bcc\0\u0204"+
    "\0\u3c22\0\u3c78\0\u0204\0\u3cce\0\u3d24\0\u3d7a\0\u3dd0\0\u3e26"+
    "\0\u0204\0\u3e7c\0\u3ed2\0\u0204\0\u3f28\0\u0204\0\u3f7e\0\u3fd4"+
    "\0\u402a\0\u0204\0\u4080\0\u40d6\0\u412c\0\u4182\0\u41d8\0\u422e"+
    "\0\u4284\0\u0204\0\u0204\0\u0204\0\u0204\0\u42da\0\u0204\0\u4330"+
    "\0\u0204\0\u4386\0\u43dc\0\u4432\0\u4488\0\u44de\0\u0204\0\u4534"+
    "\0\u0204\0\u458a\0\u0204\0\u45e0\0\u0204\0\u0204\0\u0204\0\u4636"+
    "\0\u468c\0\u46e2\0\u4738\0\u478e\0\u47e4\0\u0204\0\u0204\0\u483a"+
    "\0\u0204\0\u0204\0\u0204\0\u4890\0\u48e6\0\u493c\0\u4992\0\u49e8"+
    "\0\u4a3e\0\u4a94\0\u4aea\0\u0204\0\u0204\0\126\0\u2c02\0\u4b40"+
    "\0\u4b96\0\u4bec\0\u4c42\0\126\0\u4c98\0\u0204";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[310];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\2\2\3\1\2\1\3\1\4\1\2\1\5\1\6"+
    "\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16"+
    "\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26"+
    "\1\27\1\30\1\31\1\32\1\2\1\33\1\34\7\10"+
    "\1\35\1\10\1\36\1\37\4\10\1\40\1\2\1\41"+
    "\1\42\1\43\1\44\1\45\1\46\1\47\1\50\1\51"+
    "\1\52\1\53\1\10\1\54\1\10\1\55\1\56\1\57"+
    "\1\60\1\61\1\10\1\62\1\63\1\64\1\65\1\10"+
    "\1\66\1\10\1\67\1\70\1\71\1\72\1\73\5\2"+
    "\130\0\1\3\156\0\1\74\72\0\2\6\1\0\2\6"+
    "\1\0\2\6\1\75\47\6\1\76\45\6\2\77\4\0"+
    "\107\77\1\100\3\77\1\0\3\77\1\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\30\10\4\0\1\10\1\0\1\10\35\0\1\101\106\0"+
    "\1\102\16\0\1\103\72\0\2\13\1\0\2\13\1\0"+
    "\7\13\1\104\42\13\1\105\45\13\20\0\1\106\12\0"+
    "\1\107\125\0\1\110\125\0\1\111\116\0\1\112\1\0"+
    "\2\113\131\0\1\114\116\0\1\113\1\0\2\25\10\0"+
    "\1\115\1\0\1\116\1\117\1\120\3\0\1\121\5\0"+
    "\1\122\4\0\1\25\2\0\1\115\1\0\1\116\1\117"+
    "\1\120\4\0\1\121\13\0\1\122\36\0\1\113\1\0"+
    "\2\25\12\0\1\116\1\117\1\120\3\0\1\121\12\0"+
    "\1\25\4\0\1\116\1\117\1\120\4\0\1\121\60\0"+
    "\1\123\1\124\1\125\124\0\1\126\32\0\1\127\72\0"+
    "\1\130\1\131\117\0\2\33\7\0\20\33\4\0\1\33"+
    "\1\0\30\33\6\0\2\33\1\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\12\10\1\132\5\10\4\0\1\10"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\14\10\1\133\13\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\13\10"+
    "\1\134\4\10\4\0\1\10\1\0\30\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\15\10\1\135\2\10\4\0\1\10\1\0\30\10"+
    "\4\0\1\10\1\0\1\10\35\0\1\136\72\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\137"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\1\10\1\140\10\10\1\141\1\10\1\142\13\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\4\10"+
    "\1\143\13\10\1\144\7\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\1\145\6\10\1\146\2\10\1\147"+
    "\15\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\4\10\1\150\10\10\1\151\12\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\12\10\1\152\1\10\1\153"+
    "\7\10\1\154\1\10\1\155\1\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\1\156\14\10\1\157\12\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\4\10"+
    "\1\160\14\10\1\161\6\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\5\10\1\162\6\10\1\163\13\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\1\164"+
    "\14\10\1\165\12\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\15\10\1\166\12\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\167\3\10\1\170"+
    "\4\10\1\171\12\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\16\10\1\172\1\10\1\173\7\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\16\10\1\174"+
    "\1\10\1\175\2\10\1\176\4\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\1\177\3\10\1\200\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\2\10"+
    "\1\201\1\10\1\202\5\10\1\203\5\10\1\204\2\10"+
    "\1\205\3\10\1\206\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\7\10\1\207\10\10\1\210\7\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\14\10\1\211"+
    "\13\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\7\10\1\212\20\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\10\10\1\213\17\10\4\0\1\10\1\0"+
    "\1\10\35\0\1\214\62\0\1\215\7\0\1\6\1\216"+
    "\2\6\1\216\1\217\120\6\2\77\4\0\113\77\1\0"+
    "\3\77\1\0\2\100\4\220\111\100\1\221\1\100\1\220"+
    "\3\100\1\220\1\13\1\222\2\13\1\222\1\223\120\13"+
    "\33\0\1\224\120\0\2\113\12\0\1\116\1\117\1\120"+
    "\16\0\1\113\4\0\1\116\1\117\1\120\61\0\2\115"+
    "\20\0\1\121\12\0\1\115\13\0\1\121\47\0\1\225"+
    "\1\0\1\225\2\0\2\225\12\0\1\116\1\0\1\120"+
    "\16\0\1\225\4\0\1\116\1\0\1\120\57\0\1\226"+
    "\1\0\2\227\7\0\6\227\3\0\1\121\12\0\1\227"+
    "\1\0\6\227\4\0\1\121\61\0\1\230\163\0\1\231"+
    "\67\0\1\232\72\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\3\10\1\233\14\10\4\0\1\10\1\0\30\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\22\10"+
    "\1\234\5\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\16\10\1\235\1\10"+
    "\4\0\1\10\1\0\30\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\4\10"+
    "\1\236\1\237\3\10\1\240\6\10\4\0\1\10\1\0"+
    "\30\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\15\10\1\241\12\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\10\10\1\242\17\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\3\10\1\243\24\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\6\10\1\244"+
    "\21\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\4\10\1\245\23\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\21\10\1\246\1\247\5\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\15\10\1\250\12\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\1\251"+
    "\27\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\5\10\1\252\22\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\21\10\1\253\6\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\3\10\1\254\15\10\1\255"+
    "\6\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\1\256\27\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\4\10\1\257\3\10\1\260\17\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\10\10\1\256\1\10"+
    "\1\261\15\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\20\10\1\262\7\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\22\10\1\263\5\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\23\10\1\264\4\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\13\10"+
    "\1\265\14\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\1\266\14\10\1\267\12\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\3\10\1\270\24\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\26\10\1\271"+
    "\1\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\12\10\1\272\15\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\22\10\1\273\5\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\274\23\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\10\10\1\275"+
    "\4\10\1\257\12\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\22\10\1\276\5\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\10\10\1\277\3\10\1\266"+
    "\13\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\1\300\2\10\1\301\13\10\1\302\1\10\1\303\1\304"+
    "\5\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\1\274\27\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\12\10\1\305\15\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\306\23\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\1\307\27\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\1\10\1\174"+
    "\14\10\1\310\11\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\21\10\1\311\6\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\312\13\10\1\313"+
    "\7\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\23\10\1\314\4\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\3\10\1\315\6\10\1\316\7\10\1\317"+
    "\5\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\4\10\1\320\3\10\1\321\17\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\322\23\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\6\1\216\2\6\1\216"+
    "\1\217\2\6\1\75\47\6\1\76\52\6\1\0\2\6"+
    "\1\75\47\6\1\76\45\6\117\220\1\323\6\220\1\13"+
    "\1\222\2\13\1\222\1\223\7\13\1\104\42\13\1\105"+
    "\52\13\1\0\7\13\1\104\42\13\1\105\45\13\26\0"+
    "\2\225\12\0\1\116\1\0\1\120\16\0\1\225\4\0"+
    "\1\116\1\0\1\120\61\0\2\324\7\0\6\324\16\0"+
    "\1\324\1\0\6\324\57\0\1\324\1\0\2\227\7\0"+
    "\6\227\3\0\1\121\2\0\1\117\7\0\1\227\1\0"+
    "\6\227\4\0\1\121\3\0\1\117\115\0\1\325\32\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\4\10\1\326\23\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\12\10\1\327\5\10\4\0\1\10\1\0\30\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\10\10\1\330\7\10\4\0\1\10\1\0"+
    "\30\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\10\10\1\331\7\10\4\0"+
    "\1\10\1\0\30\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\20\10\1\260\7\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\1\332\27\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\10\10\1\333\17\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\1\334"+
    "\27\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\4\10\1\335\23\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\2\10\1\336\25\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\13\10\1\267\2\10\1\174"+
    "\11\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\21\10\1\337\6\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\10\10\1\340\17\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\341\3\10\1\342"+
    "\17\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\23\10\1\343\4\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\12\10\1\174\15\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\2\10\1\174\25\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\22\10\1\174"+
    "\5\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\21\10\1\344\6\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\11\10\1\174\1\10\1\345\14\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\21\10\1\174"+
    "\6\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\1\10\1\174\26\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\1\10\1\346\26\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\3\10\1\174\24\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\16\10\1\174"+
    "\11\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\23\10\1\347\4\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\22\10\1\350\5\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\14\10\1\174\13\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\14\10\1\260"+
    "\13\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\2\10\1\174\16\10\1\174\6\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\21\10\1\351\6\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\3\10\1\352"+
    "\24\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\15\10\1\353\12\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\23\10\1\354\4\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\2\10\1\355\25\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\20\10\1\356"+
    "\2\10\1\357\4\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\4\10\1\360\1\361\22\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\4\10\1\267\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\14\10"+
    "\1\266\13\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\4\10\1\362\23\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\22\10\1\363\5\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\14\10\1\364\13\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\15\10"+
    "\1\365\12\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\4\10\1\366\23\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\367\23\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\4\10\1\370\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\10\10"+
    "\1\371\17\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\14\10\1\372\13\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\12\10\1\373\15\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\12\10\1\374\15\10"+
    "\4\0\1\10\1\0\1\10\30\0\2\324\7\0\6\324"+
    "\6\0\1\117\7\0\1\324\1\0\6\324\10\0\1\117"+
    "\117\0\1\375\30\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\6\10\1\376\21\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\2\10\1\377\15\10\4\0\1\10"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\11\10\1\u0100\6\10"+
    "\4\0\1\10\1\0\30\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\12\10"+
    "\1\u0101\5\10\4\0\1\10\1\0\30\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\21\10\1\u0102\6\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\14\10"+
    "\1\u0103\13\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\11\10\1\u0104\16\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\7\10\1\174\20\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\21\10\1\u0105\6\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\14\10"+
    "\1\u0106\13\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\5\10\1\u0107\22\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\20\10\1\u0108\7\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\4\10\1\u0109\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\1\260"+
    "\27\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\3\10\1\u010a\24\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\12\10\1\u010b\15\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\4\10\1\174\23\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\12\10\1\u010c"+
    "\15\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\10\10\1\u010d\17\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\23\10\1\u010e\4\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\27\10\1\u010f\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\20\10\1\u0110\7\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\2\10"+
    "\1\260\25\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\20\10\1\u0111\7\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\u0112\23\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\25\10\1\174\2\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\5\10"+
    "\1\u0113\22\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\10"+
    "\1\0\21\10\1\u0114\6\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\12\10\1\u0115\15\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\4\10\1\u0116\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\3\10"+
    "\1\u0117\24\10\4\0\1\10\1\0\1\10\103\0\1\u0118"+
    "\24\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\u0119\23\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\13\10\1\u011a\4\10\4\0\1\10\1\0\30\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\4\10\1\u011b\13\10\4\0\1\10"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\4\10\1\u011c\13\10"+
    "\4\0\1\10\1\0\30\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\u011d\23\10\4\0\1\10"+
    "\1\0\1\10\2\0\1\10\11\0\1\10\13\0\2\10"+
    "\7\0\20\10\4\0\1\10\1\0\4\10\1\u011e\23\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\10\1\0\1\174"+
    "\27\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\4\10\1\u011f\23\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\10\10\1\u0120\17\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\20\10\1\351\7\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\4\10\1\u0121"+
    "\23\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\14\10\1\u0122\13\10\4\0\1\10\1\0\1\10\2\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\13\10\1\174\14\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\20\10\4\0\1\10\1\0\21\10\1\u0123\6\10\4\0"+
    "\1\10\1\0\1\10\3\0\5\u0124\113\0\2\u0124\3\0"+
    "\1\10\11\0\1\10\13\0\2\10\7\0\20\10\4\0"+
    "\1\10\1\0\20\10\1\174\7\10\4\0\1\10\1\0"+
    "\1\10\2\0\1\10\11\0\1\10\13\0\2\10\7\0"+
    "\3\10\1\u0125\14\10\4\0\1\10\1\0\30\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\u0126\1\0\30\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\u0127\1\0\30\10\4\0"+
    "\1\10\1\0\1\10\2\0\1\10\11\0\1\10\13\0"+
    "\2\10\7\0\20\10\4\0\1\10\1\0\3\10\1\u0128"+
    "\24\10\4\0\1\10\1\0\1\10\2\0\1\10\11\0"+
    "\1\10\13\0\2\10\7\0\20\10\4\0\1\10\1\0"+
    "\14\10\1\u0129\13\10\4\0\1\10\1\0\1\10\2\0"+
    "\33\u0124\1\u012a\32\u0124\1\0\2\u0124\1\0\1\u0124\1\0"+
    "\1\u0124\1\0\3\u0124\1\0\24\u0124\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\10\10\1\u012b\7\10\4\0\1\10"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\u012c"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\7\0\20\10\4\0\1\u012d"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\2\0\1\10"+
    "\11\0\1\10\13\0\2\10\5\0\1\u012e\1\0\20\10"+
    "\4\0\1\10\1\0\30\10\4\0\1\10\1\0\1\10"+
    "\2\0\1\10\11\0\1\10\13\0\2\10\7\0\20\10"+
    "\4\0\1\10\1\0\4\10\1\u012f\23\10\4\0\1\10"+
    "\1\0\1\10\73\0\1\u0130\34\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\12\10\1\u0131\5\10\4\0\1\10"+
    "\1\0\30\10\4\0\1\10\1\0\1\10\103\0\1\u0132"+
    "\24\0\1\10\11\0\1\10\13\0\2\10\7\0\6\10"+
    "\1\u0133\11\10\4\0\1\10\1\0\30\10\4\0\1\10"+
    "\1\0\1\10\72\0\1\u0134\35\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\u0135\1\0\30\10"+
    "\4\0\1\10\1\0\1\10\2\0\1\10\11\0\1\10"+
    "\13\0\2\10\7\0\20\10\4\0\1\u0136\1\0\30\10"+
    "\4\0\1\10\1\0\1\10\2\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[19694];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\2\11\10\1\2\11\2\1\1\11\5\1\2\11"+
    "\10\1\2\11\2\1\1\11\23\1\1\11\1\1\4\11"+
    "\1\0\2\1\4\11\1\0\1\1\4\11\1\1\1\11"+
    "\1\1\1\11\1\1\2\11\2\1\3\11\1\0\1\11"+
    "\5\1\1\11\55\1\2\11\2\1\1\0\3\1\1\11"+
    "\1\1\1\0\1\1\1\11\1\0\1\11\70\1\1\11"+
    "\2\0\47\1\1\0\32\1\1\0\21\1\1\0\3\1"+
    "\1\11\1\1\1\0\1\1\1\0\1\1\1\11\2\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[310];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
  public final int getTokenStart() {
      return (int) yychar;
  }

  public final int getTokenEnd() {
      return getTokenStart() + yylength();
  }


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public RubyLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  @NotNull
  public RubyToken advance() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
              {
                return RubyToken.EOF;
              }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return RubyToken.BAD_CHARACTER;
            }
            // fall through
          case 100: break;
          case 2:
            { return RubyToken.WHITESPACE;
            }
            // fall through
          case 101: break;
          case 3:
            { return RubyToken.NOT;
            }
            // fall through
          case 102: break;
          case 4:
            { return RubyToken.DOUBLE_QUOTED_STRING;
            }
            // fall through
          case 103: break;
          case 5:
            { return RubyToken.LINE_COMMENT;
            }
            // fall through
          case 104: break;
          case 6:
            { return RubyToken.IDENTIFIER;
            }
            // fall through
          case 105: break;
          case 7:
            { return RubyToken.MOD;
            }
            // fall through
          case 106: break;
          case 8:
            { return RubyToken.AND;
            }
            // fall through
          case 107: break;
          case 9:
            { return RubyToken.SINGLE_QUOTED_STRING;
            }
            // fall through
          case 108: break;
          case 10:
            { return RubyToken.LPAREN;
            }
            // fall through
          case 109: break;
          case 11:
            { return RubyToken.RPAREN;
            }
            // fall through
          case 110: break;
          case 12:
            { return RubyToken.MULT;
            }
            // fall through
          case 111: break;
          case 13:
            { return RubyToken.PLUS;
            }
            // fall through
          case 112: break;
          case 14:
            { return RubyToken.COMMA;
            }
            // fall through
          case 113: break;
          case 15:
            { return RubyToken.MINUS;
            }
            // fall through
          case 114: break;
          case 16:
            { return RubyToken.DOT;
            }
            // fall through
          case 115: break;
          case 17:
            { return RubyToken.DIV;
            }
            // fall through
          case 116: break;
          case 18:
            { return RubyToken.INTEGER_LITERAL;
            }
            // fall through
          case 117: break;
          case 19:
            { return RubyToken.COLON;
            }
            // fall through
          case 118: break;
          case 20:
            { return RubyToken.SEMICOLON;
            }
            // fall through
          case 119: break;
          case 21:
            { return RubyToken.LT;
            }
            // fall through
          case 120: break;
          case 22:
            { return RubyToken.EQ;
            }
            // fall through
          case 121: break;
          case 23:
            { return RubyToken.GT;
            }
            // fall through
          case 122: break;
          case 24:
            { return RubyToken.INSTANCE_VARIABLE;
            }
            // fall through
          case 123: break;
          case 25:
            { return RubyToken.LBRACK;
            }
            // fall through
          case 124: break;
          case 26:
            { return RubyToken.RBRACK;
            }
            // fall through
          case 125: break;
          case 27:
            { return RubyToken.XOR;
            }
            // fall through
          case 126: break;
          case 28:
            { return RubyToken.BACKTICK;
            }
            // fall through
          case 127: break;
          case 29:
            { return RubyToken.METHOD;
            }
            // fall through
          case 128: break;
          case 30:
            { return RubyToken.LBRACE;
            }
            // fall through
          case 129: break;
          case 31:
            { return RubyToken.OR;
            }
            // fall through
          case 130: break;
          case 32:
            { return RubyToken.RBRACE;
            }
            // fall through
          case 131: break;
          case 33:
            { return RubyToken.TILDE;
            }
            // fall through
          case 132: break;
          case 34:
            { return RubyToken.NOTEQ;
            }
            // fall through
          case 133: break;
          case 35:
            { return RubyToken.MODEQ;
            }
            // fall through
          case 134: break;
          case 36:
            { return RubyToken.ANDAND;
            }
            // fall through
          case 135: break;
          case 37:
            { return RubyToken.ANDEQ;
            }
            // fall through
          case 136: break;
          case 38:
            { return RubyToken.POW;
            }
            // fall through
          case 137: break;
          case 39:
            { return RubyToken.MULTEQ;
            }
            // fall through
          case 138: break;
          case 40:
            { return RubyToken.PLUSEQ;
            }
            // fall through
          case 139: break;
          case 41:
            { return RubyToken.MINUSEQ;
            }
            // fall through
          case 140: break;
          case 42:
            { return RubyToken.RANGE;
            }
            // fall through
          case 141: break;
          case 43:
            { return RubyToken.DOUBLE_LITERAL;
            }
            // fall through
          case 142: break;
          case 44:
            { return RubyToken.DIVEQ;
            }
            // fall through
          case 143: break;
          case 45:
            { return RubyToken.FLOAT_LITERAL;
            }
            // fall through
          case 144: break;
          case 46:
            { return RubyToken.LONG_LITERAL;
            }
            // fall through
          case 145: break;
          case 47:
            { return RubyToken.LTLT;
            }
            // fall through
          case 146: break;
          case 48:
            { return RubyToken.LTEQ;
            }
            // fall through
          case 147: break;
          case 49:
            { return RubyToken.LTGT;
            }
            // fall through
          case 148: break;
          case 50:
            { return RubyToken.EQEQ;
            }
            // fall through
          case 149: break;
          case 51:
            { return RubyToken.GTEQ;
            }
            // fall through
          case 150: break;
          case 52:
            { return RubyToken.GTGT;
            }
            // fall through
          case 151: break;
          case 53:
            { return RubyToken.OR_KEYWORD;
            }
            // fall through
          case 152: break;
          case 54:
            { return RubyToken.XOREQ;
            }
            // fall through
          case 153: break;
          case 55:
            { return RubyToken.DO;
            }
            // fall through
          case 154: break;
          case 56:
            { return RubyToken.IF;
            }
            // fall through
          case 155: break;
          case 57:
            { return RubyToken.IN;
            }
            // fall through
          case 156: break;
          case 58:
            { return RubyToken.OREQ;
            }
            // fall through
          case 157: break;
          case 59:
            { return RubyToken.OROR;
            }
            // fall through
          case 158: break;
          case 60:
            { return RubyToken.EMBEDDED_LITERAL;
            }
            // fall through
          case 159: break;
          case 61:
            { return RubyToken.POWEQ;
            }
            // fall through
          case 160: break;
          case 62:
            { return RubyToken.LTLTEQ;
            }
            // fall through
          case 161: break;
          case 63:
            { return RubyToken.GTGTEQ;
            }
            // fall through
          case 162: break;
          case 64:
            { return RubyToken.AND_KEYWORD;
            }
            // fall through
          case 163: break;
          case 65:
            { return RubyToken.NOT_KEYWORD;
            }
            // fall through
          case 164: break;
          case 66:
            { return RubyToken.DEF;
            }
            // fall through
          case 165: break;
          case 67:
            { return RubyToken.END;
            }
            // fall through
          case 166: break;
          case 68:
            { return RubyToken.FOR;
            }
            // fall through
          case 167: break;
          case 69:
            { return RubyToken.NIL;
            }
            // fall through
          case 168: break;
          case 70:
            { return RubyToken.CASE;
            }
            // fall through
          case 169: break;
          case 71:
            { return RubyToken.ELSE;
            }
            // fall through
          case 170: break;
          case 72:
            { return RubyToken.NEXT;
            }
            // fall through
          case 171: break;
          case 73:
            { return RubyToken.REDO;
            }
            // fall through
          case 172: break;
          case 74:
            { return RubyToken.SELF;
            }
            // fall through
          case 173: break;
          case 75:
            { return RubyToken.THEN;
            }
            // fall through
          case 174: break;
          case 76:
            { return RubyToken.TRUE;
            }
            // fall through
          case 175: break;
          case 77:
            { return RubyToken.WHEN;
            }
            // fall through
          case 176: break;
          case 78:
            { return RubyToken.ALIAS;
            }
            // fall through
          case 177: break;
          case 79:
            { return RubyToken.BEGIN;
            }
            // fall through
          case 178: break;
          case 80:
            { return RubyToken.BREAK;
            }
            // fall through
          case 179: break;
          case 81:
            { return RubyToken.CLASS;
            }
            // fall through
          case 180: break;
          case 82:
            { return RubyToken.ELSIF;
            }
            // fall through
          case 181: break;
          case 83:
            { return RubyToken.FALSE;
            }
            // fall through
          case 182: break;
          case 84:
            { return RubyToken.RETRY;
            }
            // fall through
          case 183: break;
          case 85:
            { return RubyToken.SUPER;
            }
            // fall through
          case 184: break;
          case 86:
            { return RubyToken.UNDEF;
            }
            // fall through
          case 185: break;
          case 87:
            { return RubyToken.UNTIL;
            }
            // fall through
          case 186: break;
          case 88:
            { return RubyToken.WHILE;
            }
            // fall through
          case 187: break;
          case 89:
            { return RubyToken.YIELD;
            }
            // fall through
          case 188: break;
          case 90:
            { return RubyToken.ENSURE;
            }
            // fall through
          case 189: break;
          case 91:
            { return RubyToken.MODULE;
            }
            // fall through
          case 190: break;
          case 92:
            { return RubyToken.RESCUE;
            }
            // fall through
          case 191: break;
          case 93:
            { return RubyToken.RETURN;
            }
            // fall through
          case 192: break;
          case 94:
            { return RubyToken.UNLESS;
            }
            // fall through
          case 193: break;
          case 95:
            { return RubyToken.BLOCK_COMMENT;
            }
            // fall through
          case 194: break;
          case 96:
            { return RubyToken._FILE;
            }
            // fall through
          case 195: break;
          case 97:
            { return RubyToken._LINE;
            }
            // fall through
          case 196: break;
          case 98:
            { return RubyToken.DEFINED;
            }
            // fall through
          case 197: break;
          case 99:
            { return RubyToken._ENCODING;
            }
            // fall through
          case 198: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
