/*
 * Copyright 2023 Squircle CE contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.blacksquircle.ui.language.typescript.lexer;

import org.jetbrains.annotations.NotNull;

@SuppressWarnings("all")

/**
 * This class is a scanner generated by
 * <a href="http://www.jflex.de/">JFlex</a> 1.8.2
 * from the specification file <tt>typescript.flex</tt>
 */
public class TypeScriptLexer {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0, 0
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\1\u0200\1\u0300\1\u0400\1\u0500\1\u0600\1\u0700"+
    "\1\u0800\1\u0900\1\u0a00\1\u0b00\1\u0c00\1\u0d00\1\u0e00\1\u0f00"+
    "\1\u1000\1\u0100\1\u1100\1\u1200\1\u1300\1\u0100\1\u1400\1\u1500"+
    "\1\u1600\1\u1700\1\u1800\1\u1900\1\u1a00\1\u1b00\1\u0100\1\u1c00"+
    "\1\u1d00\1\u1e00\12\u1f00\1\u2000\1\u2100\1\u2200\1\u1f00\1\u2300"+
    "\1\u2400\2\u1f00\31\u0100\1\u2500\121\u0100\1\u2600\4\u0100\1\u2700"+
    "\1\u0100\1\u2800\1\u2900\1\u2a00\1\u2b00\1\u2c00\1\u2d00\53\u0100"+
    "\1\u2e00\10\u2f00\31\u1f00\1\u0100\1\u3000\1\u3100\1\u0100\1\u3200"+
    "\1\u3300\1\u3400\1\u3500\1\u3600\1\u3700\1\u3800\1\u3900\3\u1f00"+
    "\1\u3a00\1\u3b00\1\u3c00\1\u3d00\1\u3e00\3\u1f00\1\u3f00\1\u4000"+
    "\4\u1f00\1\u4100\11\u1f00\3\u0100\1\u4200\1\u4300\13\u1f00\4\u0100"+
    "\1\u4400\63\u1f00\2\u0100\1\u4500\4\u1f00\1\u4600\100\u1f00\1\u4700"+
    "\40\u1f00\1\u4800\1\u4900\1\u1f00\1\u4a00\1\u4b00\1\u4c00\1\u4d00"+
    "\26\u1f00\1\u4e00\21\u1f00\246\u0100\1\u4f00\20\u0100\1\u5000\1\u5100"+
    "\77\u1f00\2\u0100\1\u5100\u0b05\u1f00\1\u5200\1\u5300\u02fe\u1f00";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\3\1\4\1\5\16\0\4\6"+
    "\1\1\1\7\1\10\1\6\1\11\1\12\1\13\1\14"+
    "\1\15\1\16\1\17\1\20\1\21\1\22\1\23\1\24"+
    "\1\25\11\26\1\27\1\30\1\31\1\32\1\33\1\34"+
    "\1\6\1\35\1\36\1\35\1\37\1\40\1\41\5\11"+
    "\1\42\1\11\1\43\1\11\1\44\7\11\1\45\2\11"+
    "\1\46\1\47\1\50\1\51\1\52\1\53\1\54\1\55"+
    "\1\56\1\57\1\60\1\61\1\62\1\63\1\64\1\65"+
    "\1\66\1\67\1\70\1\71\1\72\1\73\1\74\1\75"+
    "\1\76\1\77\1\100\1\101\1\102\1\103\1\104\1\105"+
    "\1\106\1\107\1\110\1\111\6\0\1\112\32\0\2\6"+
    "\4\11\4\6\1\11\2\6\1\0\7\6\1\11\4\6"+
    "\1\11\5\6\27\11\1\6\37\11\1\6\u01ca\11\4\6"+
    "\14\11\16\6\5\11\7\6\1\11\1\6\1\11\21\6"+
    "\160\0\5\11\1\6\2\11\2\6\4\11\10\6\1\11"+
    "\1\6\3\11\1\6\1\11\1\6\24\11\1\6\123\11"+
    "\1\6\213\11\1\6\5\0\2\6\236\11\11\6\46\11"+
    "\2\6\1\11\7\6\47\11\7\6\1\11\1\6\55\0"+
    "\1\6\1\0\1\6\2\0\1\6\2\0\1\6\1\0"+
    "\10\6\33\11\5\6\3\11\15\6\5\0\6\6\1\11"+
    "\4\6\13\0\5\6\53\11\37\0\4\6\2\11\1\0"+
    "\143\11\1\6\1\11\10\0\1\6\6\0\2\11\2\0"+
    "\1\6\4\0\2\11\12\0\3\11\2\6\1\11\17\6"+
    "\1\0\1\11\1\0\36\11\33\0\2\6\131\11\13\0"+
    "\1\11\16\6\12\0\41\11\11\0\2\11\4\6\1\11"+
    "\5\6\26\11\4\0\1\11\11\0\1\11\3\0\1\11"+
    "\5\0\22\6\31\11\3\0\104\6\1\11\1\6\13\11"+
    "\67\6\33\0\1\6\4\0\66\11\3\0\1\11\22\0"+
    "\1\11\7\0\12\11\2\0\2\6\12\0\1\6\7\11"+
    "\1\6\7\11\1\6\3\0\1\6\10\11\2\6\2\11"+
    "\2\6\26\11\1\6\7\11\1\6\1\11\3\6\4\11"+
    "\2\6\1\0\1\11\7\0\2\6\2\0\2\6\3\0"+
    "\1\11\10\6\1\0\4\6\2\11\1\6\3\11\2\0"+
    "\2\6\12\0\4\11\7\6\1\11\5\6\3\0\1\6"+
    "\6\11\4\6\2\11\2\6\26\11\1\6\7\11\1\6"+
    "\2\11\1\6\2\11\1\6\2\11\2\6\1\0\1\6"+
    "\5\0\4\6\2\0\2\6\3\0\3\6\1\0\7\6"+
    "\4\11\1\6\1\11\7\6\14\0\3\11\1\0\13\6"+
    "\3\0\1\6\11\11\1\6\3\11\1\6\26\11\1\6"+
    "\7\11\1\6\2\11\1\6\5\11\2\6\1\0\1\11"+
    "\10\0\1\6\3\0\1\6\3\0\2\6\1\11\17\6"+
    "\2\11\2\0\2\6\12\0\1\6\1\11\17\6\3\0"+
    "\1\6\10\11\2\6\2\11\2\6\26\11\1\6\7\11"+
    "\1\6\2\11\1\6\5\11\2\6\1\0\1\11\7\0"+
    "\2\6\2\0\2\6\3\0\10\6\2\0\4\6\2\11"+
    "\1\6\3\11\2\0\2\6\12\0\1\6\1\11\20\6"+
    "\1\0\1\11\1\6\6\11\3\6\3\11\1\6\4\11"+
    "\3\6\2\11\1\6\1\11\1\6\2\11\3\6\2\11"+
    "\3\6\3\11\3\6\14\11\4\6\5\0\3\6\3\0"+
    "\1\6\4\0\2\6\1\11\6\6\1\0\16\6\12\0"+
    "\11\6\1\11\7\6\3\0\1\6\10\11\1\6\3\11"+
    "\1\6\27\11\1\6\12\11\1\6\5\11\3\6\1\11"+
    "\7\0\1\6\3\0\1\6\4\0\7\6\2\0\1\6"+
    "\2\11\6\6\2\11\2\0\2\6\12\0\22\6\2\0"+
    "\1\6\10\11\1\6\3\11\1\6\27\11\1\6\12\11"+
    "\1\6\5\11\2\6\1\0\1\11\7\0\1\6\3\0"+
    "\1\6\4\0\7\6\2\0\7\6\1\11\1\6\2\11"+
    "\2\0\2\6\12\0\1\6\2\11\17\6\2\0\1\6"+
    "\10\11\1\6\3\11\1\6\51\11\2\6\1\11\7\0"+
    "\1\6\3\0\1\6\4\0\1\11\10\6\1\0\10\6"+
    "\2\11\2\0\2\6\12\0\12\6\6\11\2\6\2\0"+
    "\1\6\22\11\3\6\30\11\1\6\11\11\1\6\1\11"+
    "\2\6\7\11\3\6\1\0\4\6\6\0\1\6\1\0"+
    "\1\6\10\0\22\6\2\0\15\6\60\11\1\0\2\11"+
    "\7\0\4\6\10\11\10\0\1\6\12\0\47\6\2\11"+
    "\1\6\1\11\2\6\2\11\1\6\1\11\2\6\1\11"+
    "\6\6\4\11\1\6\7\11\1\6\3\11\1\6\1\11"+
    "\1\6\1\11\2\6\2\11\1\6\4\11\1\0\2\11"+
    "\6\0\1\6\2\0\1\11\2\6\5\11\1\6\1\11"+
    "\1\6\6\0\2\6\12\0\2\6\4\11\40\6\1\11"+
    "\27\6\2\0\6\6\12\0\13\6\1\0\1\6\1\0"+
    "\1\6\1\0\4\6\2\0\10\11\1\6\44\11\4\6"+
    "\24\0\1\6\2\0\5\11\13\0\1\6\44\0\11\6"+
    "\1\0\71\6\53\11\24\0\1\11\12\0\6\6\6\11"+
    "\4\0\4\11\3\0\1\11\3\0\2\11\7\0\3\11"+
    "\4\0\15\11\14\0\1\11\17\0\2\6\46\11\1\6"+
    "\1\11\5\6\1\11\2\6\53\11\1\6\115\11\1\6"+
    "\4\11\2\6\7\11\1\6\1\11\1\6\4\11\2\6"+
    "\51\11\1\6\4\11\2\6\41\11\1\6\4\11\2\6"+
    "\7\11\1\6\1\11\1\6\4\11\2\6\17\11\1\6"+
    "\71\11\1\6\4\11\2\6\103\11\2\6\3\0\40\6"+
    "\20\11\20\6\125\11\14\6\u016c\11\2\6\21\11\1\6"+
    "\32\11\5\6\113\11\3\6\3\11\17\6\15\11\1\6"+
    "\4\11\3\0\13\6\22\11\3\0\13\6\22\11\2\0"+
    "\14\6\15\11\1\6\3\11\1\6\2\0\14\6\64\11"+
    "\40\0\3\6\1\11\3\6\2\11\1\0\2\6\12\0"+
    "\41\6\3\0\2\6\12\0\6\6\130\11\10\6\51\11"+
    "\1\0\1\11\5\6\106\11\12\6\35\11\3\6\14\0"+
    "\4\6\14\0\12\6\12\0\36\11\2\6\5\11\13\6"+
    "\54\11\4\6\21\0\7\11\2\0\6\6\12\0\46\6"+
    "\27\11\5\0\4\6\65\11\12\0\1\6\35\0\2\6"+
    "\13\0\6\6\12\0\15\6\1\11\130\6\5\0\57\11"+
    "\21\0\7\11\4\6\12\0\21\6\11\0\14\6\3\0"+
    "\36\11\15\0\2\11\12\0\54\11\16\0\14\6\44\11"+
    "\24\0\10\6\12\0\3\6\3\11\12\0\44\11\122\6"+
    "\3\0\1\6\25\0\4\11\1\0\4\11\3\0\2\11"+
    "\11\6\300\11\47\0\25\6\4\0\26\11\2\6\6\11"+
    "\2\6\46\11\2\6\6\11\2\6\10\11\1\6\1\11"+
    "\1\6\1\11\1\6\1\11\1\6\37\11\2\6\65\11"+
    "\1\6\7\11\1\6\1\11\3\6\3\11\1\6\7\11"+
    "\3\6\4\11\2\6\6\11\4\6\15\11\5\6\3\11"+
    "\1\6\7\11\16\6\5\0\30\6\2\3\5\0\20\6"+
    "\2\11\23\6\1\11\13\6\5\0\5\6\6\0\1\6"+
    "\1\11\15\6\1\11\20\6\15\11\3\6\33\11\25\6"+
    "\15\0\4\6\1\0\3\6\14\0\21\6\1\11\4\6"+
    "\1\11\2\6\12\11\1\6\1\11\3\6\5\11\6\6"+
    "\1\11\1\6\1\11\1\6\1\11\1\6\4\11\1\6"+
    "\13\11\2\6\4\11\5\6\5\11\4\6\1\11\21\6"+
    "\51\11\u0177\6\57\11\1\6\57\11\1\6\205\11\6\6"+
    "\4\11\3\0\2\11\14\6\46\11\1\6\1\11\5\6"+
    "\1\11\2\6\70\11\7\6\1\11\17\6\1\0\27\11"+
    "\11\6\7\11\1\6\7\11\1\6\7\11\1\6\7\11"+
    "\1\6\7\11\1\6\7\11\1\6\7\11\1\6\7\11"+
    "\1\6\40\0\57\6\1\11\325\6\3\11\31\6\11\11"+
    "\6\0\1\6\5\11\2\6\5\11\4\6\126\11\2\6"+
    "\2\0\2\6\3\11\1\6\132\11\1\6\4\11\5\6"+
    "\51\11\3\6\136\11\21\6\33\11\65\6\306\11\112\6"+
    "\315\11\63\6\215\11\103\6\56\11\2\6\15\11\3\6"+
    "\20\11\12\0\2\11\24\6\57\11\1\0\4\6\12\0"+
    "\1\6\31\11\7\6\1\0\120\11\2\0\45\6\11\11"+
    "\2\6\147\11\2\6\4\11\1\6\4\11\14\6\13\11"+
    "\115\6\12\11\1\0\3\11\1\0\4\11\1\0\27\11"+
    "\5\0\20\6\1\11\7\6\64\11\14\6\2\0\62\11"+
    "\21\0\13\6\12\0\6\6\22\0\6\11\3\6\1\11"+
    "\4\6\12\0\34\11\10\0\2\6\27\11\15\0\14\6"+
    "\35\11\3\6\4\0\57\11\16\0\16\6\1\11\12\0"+
    "\46\6\51\11\16\0\11\6\3\11\1\0\10\11\2\0"+
    "\2\6\12\0\6\6\27\11\3\6\1\11\1\0\4\6"+
    "\60\11\1\0\1\11\3\0\2\11\2\0\5\11\2\0"+
    "\1\11\1\0\1\11\30\6\3\11\2\6\13\11\5\0"+
    "\2\6\3\11\2\0\12\6\6\11\2\6\6\11\2\6"+
    "\6\11\11\6\7\11\1\6\7\11\221\6\43\11\10\0"+
    "\1\6\2\0\2\6\12\0\6\6\244\11\14\6\27\11"+
    "\4\6\61\11\4\6\u0100\3\156\11\2\6\152\11\46\6"+
    "\7\11\14\6\5\11\5\6\1\11\1\0\12\11\1\6"+
    "\15\11\1\6\5\11\1\6\1\11\1\6\2\11\1\6"+
    "\2\11\1\6\154\11\41\6\153\11\22\6\100\11\2\6"+
    "\66\11\50\6\15\11\3\6\20\0\20\6\7\0\14\6"+
    "\2\11\30\6\3\11\31\6\1\11\6\6\5\11\1\6"+
    "\207\11\2\6\1\0\4\6\1\11\13\6\12\0\7\6"+
    "\32\11\4\6\1\11\1\6\32\11\13\6\131\11\3\6"+
    "\6\11\2\6\6\11\2\6\6\11\2\6\3\11\3\6"+
    "\2\11\3\6\2\11\22\6\3\0\4\6\14\11\1\6"+
    "\32\11\1\6\23\11\1\6\2\11\1\6\17\11\2\6"+
    "\16\11\42\6\173\11\105\6\65\11\210\6\1\0\202\6"+
    "\35\11\3\6\61\11\57\6\37\11\21\6\33\11\65\6"+
    "\36\11\2\6\44\11\4\6\10\11\1\6\5\11\52\6"+
    "\236\11\2\6\12\0\126\6\6\11\2\6\1\11\1\6"+
    "\54\11\1\6\2\11\3\6\1\11\2\6\27\11\252\6"+
    "\26\11\12\6\32\11\106\6\70\11\6\6\2\11\100\6"+
    "\1\11\3\0\1\6\2\0\5\6\4\0\4\11\1\6"+
    "\3\11\1\6\33\11\4\6\3\0\4\6\1\0\40\6"+
    "\35\11\203\6\66\11\12\6\26\11\12\6\23\11\215\6"+
    "\111\11\267\6\3\0\65\11\17\0\37\6\12\0\20\6"+
    "\3\0\55\11\13\0\2\6\1\0\22\6\31\11\7\6"+
    "\12\0\6\6\3\0\44\11\16\0\1\6\12\0\100\6"+
    "\3\0\60\11\16\0\4\11\13\6\12\0\246\6\53\11"+
    "\15\0\10\6\12\0\66\6\157\11\221\6\143\11\235\6"+
    "\57\11\321\6\71\11\307\6\105\11\13\6\1\11\56\0"+
    "\20\6\4\0\15\11\140\6\2\11\u0163\6\5\0\3\6"+
    "\26\0\2\6\7\0\36\6\4\0\224\6\3\0\273\6"+
    "\125\11\1\6\107\11\1\6\2\11\2\6\1\11\2\6"+
    "\2\11\2\6\4\11\1\6\14\11\1\6\1\11\1\6"+
    "\7\11\1\6\101\11\1\6\4\11\2\6\10\11\1\6"+
    "\7\11\1\6\34\11\1\6\4\11\1\6\5\11\1\6"+
    "\1\11\3\6\7\11\1\6\u0154\11\2\6\31\11\1\6"+
    "\31\11\1\6\37\11\1\6\31\11\1\6\37\11\1\6"+
    "\31\11\1\6\37\11\1\6\31\11\1\6\37\11\1\6"+
    "\31\11\1\6\10\11\2\6\62\0\4\11\1\6\33\11"+
    "\1\6\2\11\1\6\1\11\2\6\1\11\1\6\12\11"+
    "\1\6\4\11\1\6\1\11\1\6\1\11\6\6\1\11"+
    "\4\6\1\11\1\6\1\11\1\6\1\11\1\6\3\11"+
    "\1\6\2\11\1\6\1\11\2\6\1\11\1\6\1\11"+
    "\1\6\1\11\1\6\1\11\1\6\1\11\1\6\2\11"+
    "\1\6\1\11\2\6\4\11\1\6\7\11\1\6\4\11"+
    "\1\6\4\11\1\6\1\11\1\6\12\11\1\6\21\11"+
    "\5\6\3\11\1\6\5\11\1\6\21\11\104\6\327\11"+
    "\51\6\65\11\13\6\336\11\343\6\1\0\36\6\140\0"+
    "\200\6\360\0\20\6";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[21504];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\2\2\1\3\1\4\1\5\1\6\1\7"+
    "\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17"+
    "\1\20\2\21\1\22\1\23\1\24\1\25\1\26\1\27"+
    "\1\5\1\30\1\31\1\32\1\33\25\5\1\34\1\35"+
    "\1\36\1\37\1\40\1\4\1\0\1\41\1\42\1\43"+
    "\1\10\1\0\1\44\1\45\1\46\1\47\1\50\1\0"+
    "\1\51\1\52\1\53\1\54\1\21\2\51\1\55\1\56"+
    "\1\21\1\57\1\60\1\61\1\62\1\63\1\64\1\5"+
    "\1\65\1\0\1\33\1\5\1\66\10\5\1\67\11\5"+
    "\1\70\1\5\1\71\1\72\7\5\1\73\21\5\1\74"+
    "\1\75\2\4\2\10\1\76\1\0\1\51\1\0\1\21"+
    "\1\77\1\100\1\101\1\102\2\33\1\103\23\5\1\104"+
    "\7\5\1\105\2\5\1\106\23\5\1\107\3\5\1\110"+
    "\5\5\1\52\1\0\1\111\5\5\1\112\10\5\1\113"+
    "\1\114\4\5\1\115\1\5\1\116\7\5\1\117\16\5"+
    "\1\120\2\5\1\121\1\122\2\5\1\123\2\5\1\124"+
    "\1\5\1\125\1\126\2\5\1\127\1\130\1\131\1\132"+
    "\7\5\1\133\1\134\5\5\1\135\16\5\1\136\2\5"+
    "\1\137\5\5\1\140\1\141\1\142\6\5\1\143\1\144"+
    "\4\5\1\145\2\5\1\146\1\147\1\150\1\151\4\5"+
    "\1\152\2\5\1\153\1\154\1\155\1\156\1\5\1\157"+
    "\1\5\1\160\3\5\1\161\3\5\1\162\1\163\1\164"+
    "\1\165\4\5\1\166\1\167\3\5\1\170\3\5\1\171"+
    "\2\5\1\172\1\173\1\174\5\5\1\175\3\5\1\176"+
    "\3\5\1\177\1\200\1\201\1\5\1\202\1\203\1\5"+
    "\1\204\1\205\1\5\1\206\1\5\1\207";

  private static int [] zzUnpackAction() {
    int [] result = new int[416];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\113\0\113\0\226\0\341\0\u012c\0\u0177\0\u01c2"+
    "\0\u020d\0\u0258\0\113\0\113\0\u02a3\0\u02ee\0\113\0\u0339"+
    "\0\u0384\0\u03cf\0\u041a\0\u0465\0\113\0\113\0\u04b0\0\u04fb"+
    "\0\u0546\0\113\0\u0591\0\113\0\113\0\u05dc\0\u0627\0\u0672"+
    "\0\u06bd\0\u0708\0\u0753\0\u079e\0\u07e9\0\u0834\0\u087f\0\u08ca"+
    "\0\u0915\0\u0960\0\u09ab\0\u09f6\0\u0a41\0\u0a8c\0\u0ad7\0\u0b22"+
    "\0\u0b6d\0\u0bb8\0\u0c03\0\u0c4e\0\113\0\u0c99\0\113\0\113"+
    "\0\113\0\113\0\u0ce4\0\113\0\113\0\113\0\113\0\u0d2f"+
    "\0\113\0\113\0\113\0\113\0\113\0\u0d7a\0\u0dc5\0\u0e10"+
    "\0\u0e5b\0\113\0\u0ea6\0\113\0\u0ef1\0\113\0\113\0\u0f3c"+
    "\0\u0f87\0\113\0\113\0\113\0\113\0\u0fd2\0\u101d\0\113"+
    "\0\u1068\0\113\0\u10b3\0\u10fe\0\u1149\0\u1194\0\u11df\0\u122a"+
    "\0\u1275\0\u12c0\0\u130b\0\u1356\0\u0177\0\u13a1\0\u13ec\0\u1437"+
    "\0\u1482\0\u14cd\0\u1518\0\u1563\0\u15ae\0\u15f9\0\u0177\0\u1644"+
    "\0\u168f\0\u0177\0\u16da\0\u1725\0\u1770\0\u17bb\0\u1806\0\u1851"+
    "\0\u189c\0\u0177\0\u18e7\0\u1932\0\u197d\0\u19c8\0\u1a13\0\u1a5e"+
    "\0\u1aa9\0\u1af4\0\u1b3f\0\u1b8a\0\u1bd5\0\u1c20\0\u1c6b\0\u1cb6"+
    "\0\u1d01\0\u1d4c\0\u1d97\0\113\0\113\0\u1de2\0\u1e2d\0\u1e78"+
    "\0\u1ec3\0\113\0\u1f0e\0\u1f59\0\u1fa4\0\u1fef\0\113\0\113"+
    "\0\u203a\0\u0177\0\u2085\0\u20d0\0\u0177\0\u211b\0\u2166\0\u21b1"+
    "\0\u21fc\0\u2247\0\u2292\0\u22dd\0\u2328\0\u2373\0\u23be\0\u2409"+
    "\0\u2454\0\u249f\0\u24ea\0\u2535\0\u2580\0\u25cb\0\u2616\0\u2661"+
    "\0\u0177\0\u26ac\0\u26f7\0\u2742\0\u278d\0\u27d8\0\u2823\0\u286e"+
    "\0\u0177\0\u28b9\0\u2904\0\u0177\0\u294f\0\u299a\0\u29e5\0\u2a30"+
    "\0\u2a7b\0\u2ac6\0\u2b11\0\u2b5c\0\u2ba7\0\u2bf2\0\u2c3d\0\u2c88"+
    "\0\u2cd3\0\u2d1e\0\u2d69\0\u2db4\0\u2dff\0\u2e4a\0\u2e95\0\u0177"+
    "\0\u2ee0\0\u2f2b\0\u2f76\0\u0177\0\u2fc1\0\u300c\0\u3057\0\u30a2"+
    "\0\u30ed\0\113\0\u3138\0\113\0\u3183\0\u31ce\0\u3219\0\u3264"+
    "\0\u32af\0\u0177\0\u32fa\0\u3345\0\u3390\0\u33db\0\u3426\0\u3471"+
    "\0\u34bc\0\u3507\0\u0177\0\u0177\0\u3552\0\u359d\0\u35e8\0\u3633"+
    "\0\u0177\0\u367e\0\u0177\0\u36c9\0\u3714\0\u375f\0\u37aa\0\u37f5"+
    "\0\u3840\0\u388b\0\u0177\0\u38d6\0\u3921\0\u396c\0\u39b7\0\u3a02"+
    "\0\u3a4d\0\u3a98\0\u3ae3\0\u3b2e\0\u3b79\0\u3bc4\0\u3c0f\0\u3c5a"+
    "\0\u3ca5\0\u0177\0\u3cf0\0\u3d3b\0\u0177\0\u3d86\0\u3dd1\0\u3e1c"+
    "\0\u0177\0\u3e67\0\u3eb2\0\u0177\0\u3efd\0\u0177\0\u0177\0\u3f48"+
    "\0\u3f93\0\u0177\0\u0177\0\u0177\0\u3fde\0\u4029\0\u4074\0\u40bf"+
    "\0\u410a\0\u4155\0\u41a0\0\u41eb\0\u0177\0\u4236\0\u4281\0\u42cc"+
    "\0\u4317\0\u4362\0\u43ad\0\u0177\0\u43f8\0\u4443\0\u448e\0\u44d9"+
    "\0\u4524\0\u456f\0\u45ba\0\u4605\0\u4650\0\u469b\0\u46e6\0\u4731"+
    "\0\u477c\0\u47c7\0\u0177\0\u4812\0\u485d\0\u48a8\0\u48f3\0\u493e"+
    "\0\u4989\0\u49d4\0\u4a1f\0\u0177\0\u0177\0\u0177\0\u4a6a\0\u4ab5"+
    "\0\u4b00\0\u4b4b\0\u4b96\0\u4be1\0\u0177\0\u0177\0\u4c2c\0\u4c77"+
    "\0\u4cc2\0\u4d0d\0\u0177\0\u4d58\0\u4da3\0\u0177\0\u0177\0\u0177"+
    "\0\u0177\0\u4dee\0\u4e39\0\u4e84\0\u4ecf\0\u0177\0\u4f1a\0\u4f65"+
    "\0\u0177\0\u0177\0\u0177\0\u0177\0\u4fb0\0\u0177\0\u4ffb\0\u0177"+
    "\0\u5046\0\u5091\0\u50dc\0\u0177\0\u5127\0\u5172\0\u51bd\0\u0177"+
    "\0\u0177\0\u0177\0\u0177\0\u5208\0\u5253\0\u529e\0\u52e9\0\u0177"+
    "\0\u0177\0\u5334\0\u537f\0\u53ca\0\u0177\0\u5415\0\u5460\0\u54ab"+
    "\0\u0177\0\u54f6\0\u5541\0\u0177\0\u0177\0\u0177\0\u558c\0\u55d7"+
    "\0\u5622\0\u566d\0\u56b8\0\u0177\0\u5703\0\u574e\0\u5799\0\u0177"+
    "\0\u57e4\0\u582f\0\u587a\0\u0177\0\u0177\0\u0177\0\u58c5\0\u0177"+
    "\0\u0177\0\u5910\0\u0177\0\u0177\0\u595b\0\u0177\0\u59a6\0\u0177";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[416];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\2\2\3\1\2\1\3\1\4\1\2\1\5\1\6"+
    "\1\7\1\10\1\11\1\12\1\13\1\14\1\15\1\16"+
    "\1\17\1\20\1\21\1\22\1\23\1\24\1\25\1\26"+
    "\1\27\1\30\1\31\1\32\6\7\1\33\2\7\1\34"+
    "\1\2\1\35\1\36\1\7\1\37\1\40\1\41\1\42"+
    "\1\43\1\44\1\45\1\46\1\7\1\47\1\7\1\50"+
    "\1\51\1\52\1\53\1\54\1\55\1\7\1\56\1\57"+
    "\1\60\1\61\1\62\1\63\1\7\1\64\1\7\1\65"+
    "\1\66\1\67\1\70\1\2\115\0\1\3\142\0\1\71"+
    "\60\0\2\6\1\0\2\6\1\0\2\6\1\72\36\6"+
    "\1\73\43\6\1\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\32\7\4\0\1\7\32\0"+
    "\1\74\73\0\1\75\16\0\1\76\60\0\2\12\1\0"+
    "\2\12\1\0\6\12\1\77\32\12\1\100\43\12\32\0"+
    "\1\101\100\0\1\102\11\0\1\103\102\0\1\104\7\0"+
    "\1\105\103\0\1\106\1\0\2\107\103\0\1\110\4\0"+
    "\1\111\5\0\1\112\103\0\1\107\1\0\2\24\7\0"+
    "\1\113\1\114\1\115\1\116\1\117\2\0\1\120\4\0"+
    "\1\24\2\0\1\113\1\0\1\114\1\115\1\116\5\0"+
    "\1\117\13\0\1\120\32\0\1\107\1\0\2\24\10\0"+
    "\1\114\1\115\1\116\1\117\7\0\1\24\4\0\1\114"+
    "\1\115\1\116\5\0\1\117\54\0\1\121\1\122\112\0"+
    "\1\123\1\124\111\0\1\125\1\126\57\0\1\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\1\127\31\7\4\0\1\7\32\0\1\130\60\0\2\37"+
    "\1\0\2\37\1\0\41\37\1\131\3\37\1\132\37\37"+
    "\1\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\15\7\1\133\4\7\1\134\3\7\1\135"+
    "\3\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\10\7\1\136\5\7\1\137"+
    "\2\7\1\140\10\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\1\141\12\7"+
    "\1\142\2\7\1\143\13\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\144\11\7\1\145\13\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\13\7"+
    "\1\146\1\7\1\147\11\7\1\150\2\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\1\151\7\7\1\152\5\7\1\153\2\7\1\154"+
    "\2\7\1\155\5\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\16\7\1\156"+
    "\13\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\5\7\1\157\6\7\1\160"+
    "\1\161\4\7\1\162\7\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\163\25\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\4\7\1\164\25\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\16\7\1\165\13\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\1\166\3\7\1\167\17\7\1\170\5\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\1\7\1\171\3\7\1\172\24\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\1\173\20\7\1\174\2\7\1\175\5\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\176\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\23\7\1\177\1\200\1\7\1\201\1\7\1\202"+
    "\1\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\7\7\1\203\11\7\1\204"+
    "\6\7\1\205\1\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\15\7\1\206"+
    "\14\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\1\207\15\7\1\210\13\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\7\7\1\211\1\212\21\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\10\7\1\213\21\7\4\0\1\7\32\0"+
    "\1\214\54\0\1\215\3\0\1\6\1\216\2\6\1\216"+
    "\1\217\105\6\1\12\1\220\2\12\1\220\1\221\105\12"+
    "\23\0\1\222\114\0\2\107\10\0\1\114\1\115\1\116"+
    "\10\0\1\107\4\0\1\114\1\115\1\116\31\0\17\110"+
    "\1\223\73\110\2\111\4\0\104\111\26\0\2\113\13\0"+
    "\1\117\7\0\1\113\14\0\1\117\43\0\1\224\1\0"+
    "\1\224\2\0\2\224\10\0\1\114\1\0\1\116\10\0"+
    "\1\224\4\0\1\114\1\0\1\116\54\0\1\225\1\0"+
    "\2\226\6\0\5\226\1\117\7\0\1\226\1\0\6\226"+
    "\5\0\1\117\55\0\1\227\112\0\1\230\1\231\57\0"+
    "\1\7\10\0\1\7\13\0\2\7\6\0\6\7\1\232"+
    "\2\7\4\0\1\7\1\0\32\7\4\0\1\7\1\37"+
    "\1\233\2\37\1\233\1\234\105\37\1\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\30\7"+
    "\1\235\1\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\30\7\1\236\1\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\1\237\31\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\6\7\1\240\23\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\16\7\1\241"+
    "\13\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\4\7\1\242\25\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\22\7\1\243\1\244\6\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\1\245\31\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\15\7\1\246"+
    "\14\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\1\7\1\247\1\250\2\7"+
    "\1\251\5\7\1\252\16\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\22\7"+
    "\1\253\7\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\24\7\1\254\5\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\17\7\1\255\3\7\1\256\6\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\13\7\1\257\16\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\15\7\1\260\14\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\21\7"+
    "\1\261\10\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\16\7\1\262\13\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\15\7\1\263\14\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\23\7\1\264\6\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\17\7"+
    "\1\265\12\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\22\7\1\266\1\267"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\30\7\1\270\1\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\23\7\1\271\6\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\3\7\1\272\26\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\23\7\1\273"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\26\7\1\274\3\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\13\7\1\275\1\276\15\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\11\7\1\277\20\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\2\7"+
    "\1\300\27\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\10\7\1\301\5\7"+
    "\1\302\13\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\1\7\1\303\30\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\1\304\17\7\1\305\2\7\1\306"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\1\307\20\7\1\310\10\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\17\7\1\311\12\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\10\7\1\312\21\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\15\7"+
    "\1\313\14\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\10\7\1\314\10\7"+
    "\1\315\10\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\1\316\23\7\1\317"+
    "\3\7\1\320\1\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\17\7\1\321"+
    "\12\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\3\7\1\322\6\7\1\323"+
    "\17\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\21\7\1\324\10\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\10\7\1\325\2\7\1\326\16\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\10\7\1\327\21\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\23\7\1\330\6\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\4\7\1\331"+
    "\25\7\4\0\1\7\1\6\1\216\2\6\1\216\1\217"+
    "\2\6\1\72\36\6\1\73\50\6\1\0\2\6\1\72"+
    "\36\6\1\73\43\6\1\12\1\220\2\12\1\220\1\221"+
    "\6\12\1\77\32\12\1\100\50\12\1\0\6\12\1\77"+
    "\32\12\1\100\43\12\17\110\1\223\4\110\1\332\66\110"+
    "\25\0\2\224\10\0\1\114\1\0\1\116\10\0\1\224"+
    "\4\0\1\114\1\0\1\116\56\0\2\333\6\0\5\333"+
    "\10\0\1\333\1\0\6\333\54\0\1\333\1\0\2\226"+
    "\6\0\5\226\1\117\1\0\1\115\5\0\1\226\1\0"+
    "\6\226\5\0\1\117\3\0\1\115\51\0\1\334\60\0"+
    "\1\37\1\233\2\37\1\233\1\234\41\37\1\131\3\37"+
    "\1\132\44\37\1\0\41\37\1\131\3\37\1\132\37\37"+
    "\1\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\15\7\1\335\14\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\10\7\1\336\21\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\10\7\1\337"+
    "\21\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\13\7\1\340\16\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\1\341\31\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\342\25\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\2\7\1\343\27\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\22\7\1\344\7\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\22\7\1\345\1\346\6\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\24\7\1\347\5\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\13\7\1\350"+
    "\16\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\1\351\31\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\4\7\1\352\25\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\353\25\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\14\7\1\354\15\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\16\7\1\355\13\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\4\7\1\356\25\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\22\7"+
    "\1\357\7\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\1\360\31\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\14\7\1\361\15\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\2\7\1\362\27\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\16\7\1\363"+
    "\13\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\13\7\1\364\2\7\1\365"+
    "\13\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\23\7\1\366\6\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\367\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\16\7\1\370\13\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\24\7\1\371"+
    "\5\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\10\7\1\372\21\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\13\7\1\373\16\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\1\7\1\374\30\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\4\7\1\375"+
    "\25\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\12\7\1\376\17\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\25\7\1\377\4\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\23\7\1\u0100\6\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\13\7\1\u0101"+
    "\16\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\3\7\1\u0102\26\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\24\7\1\u0103\5\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\24\7\1\u0104\5\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\23\7\1\u0105"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\10\7\1\u0106\21\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\u0107\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\23\7\1\u0108\6\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\2\7\1\u0109"+
    "\27\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\22\7\1\u010a\7\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\16\7\1\u010b\13\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\15\7\1\u010c\14\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\4\7\1\u010d"+
    "\25\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\4\7\1\u010e\25\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\u010f\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\15\7\1\u0110\14\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\3\7\1\u0111"+
    "\26\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\1\u0112\31\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\13\7\1\u0113\16\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\7\7"+
    "\1\u0114\22\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\13\7\1\u0115\16\7"+
    "\4\0\1\7\25\0\2\333\6\0\5\333\2\0\1\115"+
    "\5\0\1\333\1\0\6\333\11\0\1\115\17\0\1\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\2\7\1\u0116\27\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\23\7"+
    "\1\u0117\6\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\15\7\1\u0118\14\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0119\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\12\7\1\u011a\17\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\7\7"+
    "\1\u011b\22\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\22\7\1\u011c\7\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\23\7\1\u011d\6\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\10\7\1\u011e\21\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\6\7"+
    "\1\u011f\23\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\1\u0120\31\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\24\7\1\u0121\5\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\23\7\1\u0122\6\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\21\7\1\u0123"+
    "\10\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\15\7\1\u0124\14\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\u0125\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\13\7\1\u0126\16\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\23\7\1\u0127"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\4\7\1\u0128\25\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\21\7\1\u0129\10\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\1\u012a\31\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\21\7\1\u012b\10\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\5\7\1\u012c\24\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\13\7\1\u012d\16\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\25\7"+
    "\1\u012e\4\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\4\7\1\u012f\25\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\2\7\1\u0130\27\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\1\u0131\31\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\1\u0132\31\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0133\11\7\1\u0134\13\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\10\7\1\u0135\21\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\16\7\1\u0136\13\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\10\7"+
    "\1\u0137\21\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\21\7\1\u0138\10\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\10\7\1\u0139\21\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\15\7\1\u013a\14\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\21\7"+
    "\1\u013b\10\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\2\7\1\u013c\27\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\7\7\1\u013d\22\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\26\7\1\u013e\3\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\22\7"+
    "\1\u013f\7\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\16\7\1\u0140\13\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\5\7\1\u0141\24\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\16\7\1\u0142\13\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\23\7"+
    "\1\u0143\6\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\4\7\1\u0144\25\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\3\7\1\u0145\26\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\23\7\1\u0146\6\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\1\u0147"+
    "\31\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\21\7\1\u0148\10\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\15\7\1\u0149\14\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\6\7\1\u014a\23\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\21\7\1\u014b"+
    "\10\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\13\7\1\u014c\16\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\u014d\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\23\7\1\u014e\6\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\3\7\1\u014f"+
    "\26\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\13\7\1\u0150\16\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\10\7\1\u0151\21\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\14\7\1\u0152\15\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\23\7\1\u0153"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\15\7\1\u0154\14\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\5\7\1\u0155\24\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\4\7\1\u0156\25\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\4\7\1\u0157"+
    "\25\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\21\7\1\u0158\10\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\23\7\1\u0159\6\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\6\7\1\u015a\23\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\23\7\1\u015b"+
    "\6\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\2\7\1\u015c\27\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\23\7\1\u015d\6\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\2\7\1\u015e\27\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\15\7\1\u015f"+
    "\14\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\21\7\1\u0160\10\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\15\7\1\u0161\14\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\2\7\1\u0162\27\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\6\7\1\u0163"+
    "\23\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\7\7\1\u0164\22\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\21\7\1\u0165\10\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\22\7\1\u0166\7\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\10\7\1\u0167"+
    "\21\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\5\7\1\u0168\24\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\10\7\1\u0169\21\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\26\7\1\u016a\3\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\10\7\1\u016b"+
    "\21\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\15\7\1\u016c\14\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\24\7\1\u016d\5\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\24\7\1\u016e\5\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\4\7\1\u016f"+
    "\25\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\4\7\1\u0170\25\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\23\7\1\u0171\6\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\22\7\1\u0172\7\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\30\7\1\u0173"+
    "\1\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\16\7\1\u0174\13\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\4\7\1\u0175\25\7\4\0\2\7\10\0"+
    "\1\7\13\0\2\7\6\0\11\7\4\0\1\7\1\0"+
    "\2\7\1\u0176\27\7\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\1\u0177\31\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0178\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\4\7\1\u0179\25\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\23\7"+
    "\1\u017a\6\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\30\7\1\u017b\1\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\13\7\1\u017c\16\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\4\7\1\u017d\25\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\16\7"+
    "\1\u017e\13\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\4\7\1\u017f\25\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\15\7\1\u0180\14\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\15\7\1\u0181\14\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\13\7"+
    "\1\u0182\16\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\2\7\1\u0183\27\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0184\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\21\7\1\u0185\10\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\15\7"+
    "\1\u0186\14\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\15\7\1\u0187\14\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0188\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\2\7\1\u0189\27\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\u018a\25\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\17\7\1\u018b\12\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\30\7\1\u018c\1\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\15\7\1\u018d\14\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\15\7"+
    "\1\u018e\14\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\4\7\1\u018f\25\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0190\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\23\7\1\u0191\6\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\23\7"+
    "\1\u0192\6\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\16\7\1\u0193\13\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\4\7\1\u0194\25\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\3\7\1\u0195\26\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\4\7"+
    "\1\u0196\25\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\10\7\1\u0197\21\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\23\7\1\u0198\6\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\3\7\1\u0199\26\7\4\0\2\7\10\0\1\7"+
    "\13\0\2\7\6\0\11\7\4\0\1\7\1\0\16\7"+
    "\1\u019a\13\7\4\0\2\7\10\0\1\7\13\0\2\7"+
    "\6\0\11\7\4\0\1\7\1\0\22\7\1\u019b\7\7"+
    "\4\0\2\7\10\0\1\7\13\0\2\7\6\0\11\7"+
    "\4\0\1\7\1\0\5\7\1\u019c\24\7\4\0\2\7"+
    "\10\0\1\7\13\0\2\7\6\0\11\7\4\0\1\7"+
    "\1\0\31\7\1\u019d\4\0\2\7\10\0\1\7\13\0"+
    "\2\7\6\0\11\7\4\0\1\7\1\0\21\7\1\u019e"+
    "\10\7\4\0\2\7\10\0\1\7\13\0\2\7\6\0"+
    "\11\7\4\0\1\7\1\0\4\7\1\u019f\25\7\4\0"+
    "\2\7\10\0\1\7\13\0\2\7\6\0\11\7\4\0"+
    "\1\7\1\0\3\7\1\u01a0\26\7\4\0\1\7";

  private static int [] zzUnpackTrans() {
    int [] result = new int[23025];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\2\11\7\1\2\11\2\1\1\11\5\1\2\11"+
    "\3\1\1\11\1\1\2\11\27\1\1\11\1\1\4\11"+
    "\1\0\4\11\1\0\5\11\1\0\3\1\1\11\1\1"+
    "\1\11\1\1\2\11\2\1\4\11\2\1\1\11\1\0"+
    "\1\11\61\1\2\11\4\1\1\11\1\0\1\1\1\0"+
    "\1\1\2\11\101\1\1\11\1\0\1\11\304\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[416];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
  public final int getTokenStart() {
      return (int) yychar;
  }

  public final int getTokenEnd() {
      return getTokenStart() + yylength();
  }


  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public TypeScriptLexer(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzBuffer.length * 2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      throw new java.io.IOException(
          "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    if (zzBuffer.length > ZZ_BUFFERSIZE) {
      zzBuffer = new char[ZZ_BUFFERSIZE];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  @NotNull
  public TypeScriptToken advance() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
              {
                return TypeScriptToken.EOF;
              }
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { return TypeScriptToken.BAD_CHARACTER;
            }
            // fall through
          case 136: break;
          case 2:
            { return TypeScriptToken.WHITESPACE;
            }
            // fall through
          case 137: break;
          case 3:
            { return TypeScriptToken.NOT;
            }
            // fall through
          case 138: break;
          case 4:
            { return TypeScriptToken.DOUBLE_QUOTED_STRING;
            }
            // fall through
          case 139: break;
          case 5:
            { return TypeScriptToken.IDENTIFIER;
            }
            // fall through
          case 140: break;
          case 6:
            { return TypeScriptToken.MOD;
            }
            // fall through
          case 141: break;
          case 7:
            { return TypeScriptToken.AND;
            }
            // fall through
          case 142: break;
          case 8:
            { return TypeScriptToken.SINGLE_QUOTED_STRING;
            }
            // fall through
          case 143: break;
          case 9:
            { return TypeScriptToken.LPAREN;
            }
            // fall through
          case 144: break;
          case 10:
            { return TypeScriptToken.RPAREN;
            }
            // fall through
          case 145: break;
          case 11:
            { return TypeScriptToken.MULT;
            }
            // fall through
          case 146: break;
          case 12:
            { return TypeScriptToken.PLUS;
            }
            // fall through
          case 147: break;
          case 13:
            { return TypeScriptToken.COMMA;
            }
            // fall through
          case 148: break;
          case 14:
            { return TypeScriptToken.MINUS;
            }
            // fall through
          case 149: break;
          case 15:
            { return TypeScriptToken.DOT;
            }
            // fall through
          case 150: break;
          case 16:
            { return TypeScriptToken.DIV;
            }
            // fall through
          case 151: break;
          case 17:
            { return TypeScriptToken.INTEGER_LITERAL;
            }
            // fall through
          case 152: break;
          case 18:
            { return TypeScriptToken.COLON;
            }
            // fall through
          case 153: break;
          case 19:
            { return TypeScriptToken.SEMICOLON;
            }
            // fall through
          case 154: break;
          case 20:
            { return TypeScriptToken.LT;
            }
            // fall through
          case 155: break;
          case 21:
            { return TypeScriptToken.EQ;
            }
            // fall through
          case 156: break;
          case 22:
            { return TypeScriptToken.GT;
            }
            // fall through
          case 157: break;
          case 23:
            { return TypeScriptToken.QUEST;
            }
            // fall through
          case 158: break;
          case 24:
            { return TypeScriptToken.LBRACK;
            }
            // fall through
          case 159: break;
          case 25:
            { return TypeScriptToken.RBRACK;
            }
            // fall through
          case 160: break;
          case 26:
            { return TypeScriptToken.XOR;
            }
            // fall through
          case 161: break;
          case 27:
            { return TypeScriptToken.SINGLE_BACKTICK_STRING;
            }
            // fall through
          case 162: break;
          case 28:
            { return TypeScriptToken.LBRACE;
            }
            // fall through
          case 163: break;
          case 29:
            { return TypeScriptToken.OR;
            }
            // fall through
          case 164: break;
          case 30:
            { return TypeScriptToken.RBRACE;
            }
            // fall through
          case 165: break;
          case 31:
            { return TypeScriptToken.TILDE;
            }
            // fall through
          case 166: break;
          case 32:
            { return TypeScriptToken.NOTEQ;
            }
            // fall through
          case 167: break;
          case 33:
            { return TypeScriptToken.MODEQ;
            }
            // fall through
          case 168: break;
          case 34:
            { return TypeScriptToken.ANDAND;
            }
            // fall through
          case 169: break;
          case 35:
            { return TypeScriptToken.ANDEQ;
            }
            // fall through
          case 170: break;
          case 36:
            { return TypeScriptToken.MULTEQ;
            }
            // fall through
          case 171: break;
          case 37:
            { return TypeScriptToken.PLUSPLUS;
            }
            // fall through
          case 172: break;
          case 38:
            { return TypeScriptToken.PLUSEQ;
            }
            // fall through
          case 173: break;
          case 39:
            { return TypeScriptToken.MINUSMINUS;
            }
            // fall through
          case 174: break;
          case 40:
            { return TypeScriptToken.MINUSEQ;
            }
            // fall through
          case 175: break;
          case 41:
            { return TypeScriptToken.DOUBLE_LITERAL;
            }
            // fall through
          case 176: break;
          case 42:
            { return TypeScriptToken.BLOCK_COMMENT;
            }
            // fall through
          case 177: break;
          case 43:
            { return TypeScriptToken.LINE_COMMENT;
            }
            // fall through
          case 178: break;
          case 44:
            { return TypeScriptToken.DIVEQ;
            }
            // fall through
          case 179: break;
          case 45:
            { return TypeScriptToken.FLOAT_LITERAL;
            }
            // fall through
          case 180: break;
          case 46:
            { return TypeScriptToken.LONG_LITERAL;
            }
            // fall through
          case 181: break;
          case 47:
            { return TypeScriptToken.LTLT;
            }
            // fall through
          case 182: break;
          case 48:
            { return TypeScriptToken.LTEQ;
            }
            // fall through
          case 183: break;
          case 49:
            { return TypeScriptToken.EQEQ;
            }
            // fall through
          case 184: break;
          case 50:
            { return TypeScriptToken.ARROW;
            }
            // fall through
          case 185: break;
          case 51:
            { return TypeScriptToken.GTEQ;
            }
            // fall through
          case 186: break;
          case 52:
            { return TypeScriptToken.GTGT;
            }
            // fall through
          case 187: break;
          case 53:
            { return TypeScriptToken.XOREQ;
            }
            // fall through
          case 188: break;
          case 54:
            { return TypeScriptToken.AS;
            }
            // fall through
          case 189: break;
          case 55:
            { return TypeScriptToken.DO;
            }
            // fall through
          case 190: break;
          case 56:
            { return TypeScriptToken.IF;
            }
            // fall through
          case 191: break;
          case 57:
            { return TypeScriptToken.IN;
            }
            // fall through
          case 192: break;
          case 58:
            { return TypeScriptToken.IS;
            }
            // fall through
          case 193: break;
          case 59:
            { return TypeScriptToken.OF;
            }
            // fall through
          case 194: break;
          case 60:
            { return TypeScriptToken.OREQ;
            }
            // fall through
          case 195: break;
          case 61:
            { return TypeScriptToken.OROR;
            }
            // fall through
          case 196: break;
          case 62:
            { return TypeScriptToken.ELLIPSIS;
            }
            // fall through
          case 197: break;
          case 63:
            { return TypeScriptToken.LTLTEQ;
            }
            // fall through
          case 198: break;
          case 64:
            { return TypeScriptToken.GTGTEQ;
            }
            // fall through
          case 199: break;
          case 65:
            { return TypeScriptToken.GTGTGT;
            }
            // fall through
          case 200: break;
          case 66:
            { return TypeScriptToken.NAN;
            }
            // fall through
          case 201: break;
          case 67:
            { return TypeScriptToken.ANY;
            }
            // fall through
          case 202: break;
          case 68:
            { return TypeScriptToken.FOR;
            }
            // fall through
          case 203: break;
          case 69:
            { return TypeScriptToken.LET;
            }
            // fall through
          case 204: break;
          case 70:
            { return TypeScriptToken.NEW;
            }
            // fall through
          case 205: break;
          case 71:
            { return TypeScriptToken.TRY;
            }
            // fall through
          case 206: break;
          case 72:
            { return TypeScriptToken.VAR;
            }
            // fall through
          case 207: break;
          case 73:
            { return TypeScriptToken.GTGTGTEQ;
            }
            // fall through
          case 208: break;
          case 74:
            { return TypeScriptToken.CASE;
            }
            // fall through
          case 209: break;
          case 75:
            { return TypeScriptToken.ELSE;
            }
            // fall through
          case 210: break;
          case 76:
            { return TypeScriptToken.ENUM;
            }
            // fall through
          case 211: break;
          case 77:
            { return TypeScriptToken.FROM;
            }
            // fall through
          case 212: break;
          case 78:
            { return TypeScriptToken.GOTO;
            }
            // fall through
          case 213: break;
          case 79:
            { return TypeScriptToken.NULL;
            }
            // fall through
          case 214: break;
          case 80:
            { return TypeScriptToken.THIS;
            }
            // fall through
          case 215: break;
          case 81:
            { return TypeScriptToken.TRUE;
            }
            // fall through
          case 216: break;
          case 82:
            { return TypeScriptToken.TYPE;
            }
            // fall through
          case 217: break;
          case 83:
            { return TypeScriptToken.VOID;
            }
            // fall through
          case 218: break;
          case 84:
            { return TypeScriptToken.WITH;
            }
            // fall through
          case 219: break;
          case 85:
            { return TypeScriptToken.ASYNC;
            }
            // fall through
          case 220: break;
          case 86:
            { return TypeScriptToken.AWAIT;
            }
            // fall through
          case 221: break;
          case 87:
            { return TypeScriptToken.BREAK;
            }
            // fall through
          case 222: break;
          case 88:
            { return TypeScriptToken.CATCH;
            }
            // fall through
          case 223: break;
          case 89:
            { return TypeScriptToken.CLASS;
            }
            // fall through
          case 224: break;
          case 90:
            { return TypeScriptToken.CONST;
            }
            // fall through
          case 225: break;
          case 91:
            { return TypeScriptToken.FALSE;
            }
            // fall through
          case 226: break;
          case 92:
            { return TypeScriptToken.FINAL;
            }
            // fall through
          case 227: break;
          case 93:
            { return TypeScriptToken.KEYOF;
            }
            // fall through
          case 228: break;
          case 94:
            { return TypeScriptToken.SUPER;
            }
            // fall through
          case 229: break;
          case 95:
            { return TypeScriptToken.THROW;
            }
            // fall through
          case 230: break;
          case 96:
            { return TypeScriptToken.WHILE;
            }
            // fall through
          case 231: break;
          case 97:
            { return TypeScriptToken.YIELD;
            }
            // fall through
          case 232: break;
          case 98:
            { return TypeScriptToken.BIGINT;
            }
            // fall through
          case 233: break;
          case 99:
            { return TypeScriptToken.DELETE;
            }
            // fall through
          case 234: break;
          case 100:
            { return TypeScriptToken.EXPORT;
            }
            // fall through
          case 235: break;
          case 101:
            { return TypeScriptToken.IMPORT;
            }
            // fall through
          case 236: break;
          case 102:
            { return TypeScriptToken.MODULE;
            }
            // fall through
          case 237: break;
          case 103:
            { return TypeScriptToken.NATIVE;
            }
            // fall through
          case 238: break;
          case 104:
            { return TypeScriptToken.NUMBER;
            }
            // fall through
          case 239: break;
          case 105:
            { return TypeScriptToken.OBJECT;
            }
            // fall through
          case 240: break;
          case 106:
            { return TypeScriptToken.PUBLIC;
            }
            // fall through
          case 241: break;
          case 107:
            { return TypeScriptToken.RETURN;
            }
            // fall through
          case 242: break;
          case 108:
            { return TypeScriptToken.STATIC;
            }
            // fall through
          case 243: break;
          case 109:
            { return TypeScriptToken.STRING;
            }
            // fall through
          case 244: break;
          case 110:
            { return TypeScriptToken.SWITCH;
            }
            // fall through
          case 245: break;
          case 111:
            { return TypeScriptToken.THROWS;
            }
            // fall through
          case 246: break;
          case 112:
            { return TypeScriptToken.TYPEOF;
            }
            // fall through
          case 247: break;
          case 113:
            { return TypeScriptToken.BOOLEAN;
            }
            // fall through
          case 248: break;
          case 114:
            { return TypeScriptToken.DECLARE;
            }
            // fall through
          case 249: break;
          case 115:
            { return TypeScriptToken.DEFAULT;
            }
            // fall through
          case 250: break;
          case 116:
            { return TypeScriptToken.EXTENDS;
            }
            // fall through
          case 251: break;
          case 117:
            { return TypeScriptToken.FINALLY;
            }
            // fall through
          case 252: break;
          case 118:
            { return TypeScriptToken.PACKAGE;
            }
            // fall through
          case 253: break;
          case 119:
            { return TypeScriptToken.PRIVATE;
            }
            // fall through
          case 254: break;
          case 120:
            { return TypeScriptToken.REQUIRE;
            }
            // fall through
          case 255: break;
          case 121:
            { return TypeScriptToken.UNKNOWN;
            }
            // fall through
          case 256: break;
          case 122:
            { return TypeScriptToken.CONTINUE;
            }
            // fall through
          case 257: break;
          case 123:
            { return TypeScriptToken.DEBUGGER;
            }
            // fall through
          case 258: break;
          case 124:
            { return TypeScriptToken.FUNCTION;
            }
            // fall through
          case 259: break;
          case 125:
            { return TypeScriptToken.READONLY;
            }
            // fall through
          case 260: break;
          case 126:
            { return TypeScriptToken.VOLATILE;
            }
            // fall through
          case 261: break;
          case 127:
            { return TypeScriptToken.INTERFACE;
            }
            // fall through
          case 262: break;
          case 128:
            { return TypeScriptToken.PROTECTED;
            }
            // fall through
          case 263: break;
          case 129:
            { return TypeScriptToken.PROTOTYPE;
            }
            // fall through
          case 264: break;
          case 130:
            { return TypeScriptToken.TRANSIENT;
            }
            // fall through
          case 265: break;
          case 131:
            { return TypeScriptToken.UNDEFINED;
            }
            // fall through
          case 266: break;
          case 132:
            { return TypeScriptToken.IMPLEMENTS;
            }
            // fall through
          case 267: break;
          case 133:
            { return TypeScriptToken.INSTANCEOF;
            }
            // fall through
          case 268: break;
          case 134:
            { return TypeScriptToken.CONSTRUCTOR;
            }
            // fall through
          case 269: break;
          case 135:
            { return TypeScriptToken.SYNCHRONIZED;
            }
            // fall through
          case 270: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }


}
